/* ---------------------------------------------------------------------- */
/*                                                                        */
/*                 Copyright (c) 1993, by Y.Kuznetsov                     */
/*                          09-Nov-93 04:51pm                             */
/*                                                                        */
/* ---------------------------------------------------------------------- */
/*        Macros to support loading archives from inside Multi-Edit       */
/*        NOTE: Version of ME must be 6.1Opn or higher.                   */
/*  --------------------------------------------------------------------- */
/*    ࠡ  娢 ZIP/ARJ/LZH  । ME.        */
/*  ᯮ짮  ⥬ MEUTIL1^LOADFILE  㧪 䠩 */
/*   䠩 ஬ 娢   筮.                          */
/*   EX (STARTUP.S):    Macro_to_key(<F3>,'Yarcdir',Edit);                */
/*  ᫨  , ⮡ 䠩 ࠧ  ६ ४ 뫨*/
/*  㤠 । 室 - 맮  YARCDIR^YARC_end । -   */
/*  ⥬ ᮬ EXIT.   ᤥ  ᮧ .६ */
/*  ਬ ⠪ ᯮ짮 . :                                 */
/*  STARTUP.S:                                                            */
/*  ...                                                                   */
/*    set_global_str('@ME_EXIT_MACRO@',global_str('@ME_EXIT_MACRO@') +    */
/*                   ';' + 'YARCDIR^YARC_end' );                          */
/*  ...                                                                   */
/*                                                                        */
/*  --------------------------------------------------------------------- */
/*                                                                        */
/*   Archives being unpacked in dir pointed by Temp_Path sys-var or       */
/*   environment variables TEMP/TMP. If before exit "YARC_end" macro will */
/*   be called loaded files will be deleted after asking for confirmation */
/*   (recommended to call before system macro "EXIT" in customized macro).*/
/*                                                                        */
/*   To install in DIRSHELL, change lines in DIRSHELL.S:                  */
/*    if(  (tstr == 'ARC') | (tstr == 'ZIP') | (tstr == 'LZH') ) {        */
/*      RM('ArcDir ' + dir_entry);                                        */
/*   onto new:                                                            */
/*    if(  (tstr == 'ARJ') | (tstr == 'ZIP') | (tstr == 'LZH') ) { // YK  */
/*      RM('yArcDir ' + dir_entry);                                       */
/*                                                                        */
/*   and run MEMCL.BAT in ME\UTILS dir.                                   */
/*                                                                        */
/* ---------------------------------------------------------------------- */

/*
    YARCDIR     - main macro
    YARC_SETUP  - selecting temporary dir to unpack archives
    YARC_end    - if called will delete files loaded from archives
                  w/confirmation.
*/

macro_file YARCDIR;

// Supported arcs
#define YARC_EXT '.ZIP.ARJ.LZH'

prototype PARSE_CMD {
    int parse_cmd(str& cmd,str mcro,str repl) ;
}


/* ------------------------------------------------------------

 NAME:         YARCDIR

 DESCRIPTION:  Loads the archive file into window, if there several
    files in archive allows to select which one.
    Substitutes standard macro in DIRSHELL.

 PARAMETERS:  Optionally name of an archive

 RETURNS:      return_int = 1 if OK

-------------------- 24-Oct-93 03:17pm ---------------------- */
macro YARCDIR trans2 {
str ext[5], fname[60], s1[80], cmdlst[100], cmdext[100], cmd[60],
    tfname[80], afname[80] = '', temp_string;
int ii ,jj, nw, ow, lid, orf, memreq, dc1, dc2, tmp_id;
int menu = menu_create;

    // Set TMP directory
    if ( global_str('!YARC_TEMP') == '')
      RM('YARCDIR^YARC_SETUP');

    ow = cur_window;
    orf = refresh;
    refresh = 0;

    Temp_String = FExpand( mparm_str );
    if ( file_exists( Temp_String ) == 2 ) {
      if ( str_char(Temp_String,svl(Temp_String)) != '\' ) {
        Temp_String += '\';
      }
    }

load_lab:
    call chk_wildcards;
    if ( (truncate_path(Temp_string) == '') || ( return_int == 1 ) ) {
      Return_Str = get_path(Temp_String);
      RM('FILE_PROMPT /T=YARCDIR/WM=1');
      Temp_String = Return_Str;
    }
    else goto load1_lab;

    if ( return_int ) {
        call chk_wildcards;
        if ( return_int ) goto load_lab;
    load1_lab:
        fname = Temp_String;
        ext = caps(get_extension(fname));
        if ( ( ext == '' ) || (xpos('.'+ext,YARC_EXT,1) == 0) ) {
            make_message( 'Loading file: '+fname+' ...' );
            goto load_it;
        }
        call load_arc;
        if ( afname == '' ) goto ex;

        parse_cmd(cmdext,'&F',afname);
        parse_cmd(cmdext,'&O',global_str('!YARC_TEMP'));
        make_message(cmdext);
        return_str = cmdext;
        RM('MEUTIL1^EXEC /SCREEN=3/RED=NUL/MEM='+str(memreq));
        call arc_corrname;
        if(  (file_exists(global_str('!YARC_TEMP')+afname) == 0)  ) {
        bad2:
            RM('MEERROR^MESSAGEBOX /T=YARCDIR/M=File "'+
            global_str('!YARC_TEMP')+afname+
            '" not found!/B=1');
            goto ex;
        };
        return_str = global_str('!YARC_TEMP')+afname;
        RM('LDFILES /LC=1/CW=2/NHA=1');
        set_global_str('!YARC_FILES',global_str('!YARC_FILES')+
          file_name + ' ');
    }
    goto ex1;

load_arc:
    return_int = 0;   // Assume error
    s1 = '!YARC_'+ext;
    tfname = global_str('!YARC_TEMP')+'YARCDIR.TMP';

    cmd = parse_str('/CMD=',global_str(s1))+ ' ';
    cmdlst = cmd + parse_str('/LST=',global_str(s1));
    cmdext = cmd + parse_str('/EXT=',global_str(s1));
    memreq = parse_int('/MEM=',global_str(s1)) * 64;

    parse_cmd(cmdlst,'&A',fname);
    parse_cmd(cmdext,'&A',fname);

    make_message(cmdlst);
    return_str = cmdlst;
    RM('MEUTIL1^EXEC /SCREEN=3/RED='+tfname+'/MEM='+str(memreq));

    if(  (file_exists(tfname) == 0)  ) {
    bad1:
        beep; beep;
        RET;
    };

    return_str = tfname;
    RM('LDFILES /LC=1/CW=2/NHA=1');
    if ( at_eof ) {
      delete_window;
      goto bad1;
    }
    tof;
    tmp_id = window_id;

    if ( find_text(parse_str('/BEG1=',global_str(s1)),0,_RegExp | _OldExp) )
      find_text(parse_str('/BEG2=',global_str(s1)),0,_RegExp | _OldExp);
    ii = c_line + parse_int('/DN=',global_str(s1));
    tof;
    for ( jj=1; jj<=ii; jj++  ) {
      del_line;
    }
    if ( find_text(parse_str('/END=',global_str(s1)),0,_RegExp | _OldExp ) ) {
      ii = c_line - parse_int('/UP=',global_str(s1));
      goto_line( ii );
      while ( NOT(at_eof) ) {
        del_line;
      }
    }

    // Deleting column block if defined /DC1, /DC2
    if ( (dc1 = parse_int('/DC1=',global_str(s1)) ) != 0 ) {
      dc2 = parse_int('/DC2=',global_str(s1));
      tof;
      goto_col(dc1);
      col_block_begin;
      eof;
      goto_col(dc2);
      block_end;
      delete_block;
    }

    eof;
    if ( at_eol ) {
      up;
      goto_col(1);
    }
    if ( c_line == 1 ) {  // Only one file
      call get_arc_fname;
    }
    else {
        menu_set_item(menu,1,"Select file:","","/L=1/C=2/DC=1/WIN=" + str(cur_window) ,15,0,0);
        Return_Int = menu;
        RM("USERIN^DATA_IN /HN=1/A=2/PRE=V/#=1/DBL=1/T=YARCDIR");
        if ( return_int ) {
            call get_arc_fname;
        }
    }

    if ( switch_win_id( tmp_id ) ) delete_window;
    del_file( tfname );
    RET;

chk_wildcards:
    return_int = 0;
    if ( (xpos('*',Temp_String,1) != 0) || (xpos('?',Temp_String,1) != 0))
      return_int = 1;
    ret;

get_arc_fname:
    // get no of word of filename, negative means counting from end
    nw = parse_int('/WRD=',global_str(s1));
    if ( nw > 0 ) {
      for ( jj=0; jj<nw; jj++ ) {
        forward_till_not(' |9');
        afname = get_word(' |9');
      }
    }
    else {
      eol; left;
      ii = 0;
      while ( (ii>nw) && (c_col>1) ) {
        if ( xpos(cur_char,' |9',1) != 0 ) {
          ii--;
          if ( (ii == nw) || (c_col==1) ) {
            if ( c_col > 1) right;
              afname = get_word(' |9');
            ret;
          }
          while ( xpos(cur_char,' |9',1) != 0 ) {
            left;
          }
        }
        else left;
      }
    }
    RET;

  // Removing path from file-name, PKZIP's "/" chars.
arc_corrname:
    if ( xpos("/",afname,1) == 0 )
        afname = truncate_path(afname);
    else {
      ii = svl(afname);
      while ( ii>1 ) {
        if ( str_char(afname,ii) == "/" ) {
          afname = copy(afname,ii+1,svl(afname)-ii+1);
          ret;
        }
        --ii;
      }
    }
    ret;

load_it:
    return_str = fname;
    RM( 'LDFILES /LC=1/NC=1' );
    goto ex1;

ex:
  switch_window( ow );
ex1:
  refresh = orf;
  menu_delete( menu );
  redraw;
}


/* ------------------------------------------------------------
    Expanding name macros (&A,&F,&O)
   ------------------------------------------------------------ */
    int parse_cmd(str& cmd,str mcro,str repl)
{
    int ii, jj;

    if ( (ii = xpos(mcro,cmd,1)) > 0 ) {
        cmd = str_del(cmd,ii,length(mcro));
        cmd = str_ins(repl,cmd,ii);
        return ( 1 );
    }
    else return ( 0 );
}


macro YARC_SETUP {
str tmppath[120];

    // Set temporary path
    if ( Temp_Path != '') tmppath = Temp_Path;
    else if ( get_environment('TEMP') != '' )
      tmppath = get_environment('TEMP');
    else if ( get_environment('TMP') != '' )
      tmppath = get_environment('TMP');
    else
      tmppath = '.\';

    if ( copy(tmppath,svl(tmppath),1) != '\' ) {
      tmppath += '\';
    }
    set_global_str('!YARC_TEMP',FExpand(tmppath));

    set_global_str('!YARC_ZIP','/CMD=PKUNZIP/LST=-v &A/EXT=-o &A &F &O'+
      '/BEG1=% Length ?*$/BEG2=% -----/DN=0/END=% ----/UP=0/WRD=-1'+
      '/DC1=48/DC2=61/MEM=250');
    set_global_str('!YARC_ARJ','/CMD=ARJ/LST=l &A/EXT=e -y &A &O &F'+
      '/BEG1=%Filename ?*$/BEG2=%-----/DN=0/END=%----/UP=0/WRD=1/MEM=350');
    set_global_str('!YARC_LZH','/CMD=LHA/LST=l &A/EXT=e //c //m &A &O &F'+
      '/BEG1=%  Name ?*$/BEG2=%-----/DN=0/END=%----/UP=0/WRD=1'+
      '/DC1=1/DC2=2/MEM=250');

}


// Must be called before exit from ME in order to
// delete files loaded via YARCDIR macro.
macro YARC_end {
str s1[300], s2[80];
int ii, ow, orf;

    s1 = global_str('!YARC_FILES');
    if ( s1 == '' ) goto ex;
    orf = refresh ;
    ow = cur_window;

    while( remove_space( s1 ) != '' ) {
      if ( (ii = xpos(' ',s1,1)) == 0 ) break;
      s2 = copy(s1,1,ii-1);
      if ( ii >= svl(s1) ) s1='';
      else s1 = str_del(s1, 1, ii);
      Return_Str = s2;
      RM("USERIN^QUERYBOX /W=50/P=Delete file?:/T=YARCDIR-Unload/C=3/L=6");
      if ( return_int  )  {
        if ( cur_window == ow ) ow = -1;
        if ( switch_file( s2 ) ) {
          RM( 'WINOP /T=1');
        }
        del_file( s2 );
      }
    }

    set_global_str('!YARC_ZIP','');
    set_global_str('!YARC_ARJ','');
    set_global_str('!YARC_LZH','');

    set_global_str('!YARC_TEMP','');
    set_global_str('!YARC_FILES','');
    if ( ow > 0) switch_window( ow );
    refresh = orf;
ex:

}
