/* ---------------------------------------------------------------------- */
/*                                                                        */
/*                 Copyright (c) 1992, by Y.Kuznetsov                     */
/*                          21-Jul-93 03:18pm                             */
/*                          FIDO 2:5020/132.9                             */
/* ---------------------------------------------------------------------- */
/*                                                                        */
/* Macro to use Multi-Editor for generating FREQ and ATTACH messages.     */
/* To be used with FrontDoor v2.02 .. 2.20                                */
/*                                                                        */
/* ---------------------------------------------------------------------- */

/*
    File REQUEST & ATTACH for FrontDoor. Generates *.MSG files.
         ^^^^^^^ ^ ^^^^^^
             ME 6.1oPN  !
              -   

    ,   । _ਢ_ :
        ਩ 㧭殢, FIDO 2:5020/132.9

      ⨪,   ᮢ:
    ----------------------------------------------------------------------
     ᮢ (2:5020/99.21),     饭 (2:5020/51.36)
     異  (2:5020/158)...

    Special thanks to: Americam Cybernetics, Inc. for the nice & cheap ( :)
    tool.

    ன.
    ----------
    । ᪮ । defin-, 稭騥  "#define YF_S_"
      ࠬ (䠩 Yfreq.sh),  ⪮.

    ⠩ 䠩 YFREQ.DOC!

*/

macro_file YFREQ;

// 㪨   ⮣ 䠩,  ! ..
#define YF_S_NAME       'YFREQ 1.11.3'

// ন 娢
#define YF_S_WSEMAPHORE 'FDRENUM.000'   // While creating FREQ/ATTACH
#define YF_I_WAITT      20              // Waiting for semaphores (sec)

#include YFREQ.SH

// ------------------------ Whats New ---------------------------------
// 1.11.3 21-Nov-93 07:38pm - few bugs killed: when changing filelist in
//   menu->list... FDRESCAN now created after all changes in NETMAIL.
// 1.11 - 11-13-93 01:57am
//   Added new file YARC.S, all archive processing moved there, few names
//   of globals changed. Corrected processing ARCs w/pathnames.
//   Corrected 'save_key/restore_key' functions. Few bugs ;( killed again );.
// 1.10 - 04-Nov-93 08:05pm
//   'REPLY' kludge removed. Parameter /MEM in EXEC for archivers and for
//   GREP decreased which speeded up things a lot. Few bugs killed.
//   *** Embedded support for FDRESCAN.*,FDRENUM.*.
//   Size of requested files being shown now in buffer and prompts!
//   SHARE must be loaded for multitaskers!
//   *** A lot of changes in menu topic "lisT" - Del/Rename/Chg.attr
// 1.09 - 24-Oct-93 01:43pm
//   Filenames got by <CTRL-F> now can be modified. Not complete manually
//   entered addresses will be filled ('corr_addr' function added).
//   FREQ window created only when 1st file requested and closed after
//   MSG file generated.
//   *** Now you can work with achives ARJ/ZIP/LZH!
// 1.08 - 10-Oct-93 07:08pm
//   User changeable part moved to YFREQ.SH include file. Added YFREQ.DOC.
//   Added FPU flag(for FD2.20). Just another bug killed in condense mode.
//   *** New menu item "lisT" - creates list of all FREQ/ATT messages
// 1.07 - 19-Sep-93 01:40pm
//   Corrected bug in screen updating/restoring.
//   Changed UI in condense search. Seeking for 'SysOp' enhanced.
//   Now creating the RESCAN semaphore. See. "define YF_S_RESCAN".
// 1.05,1.06 - 11-Sep-93 01:07am
//   Corrected two bugs in condense mode.
// 1.04 - 20-Aug-93 05:12pm
//   added condense mode: seeking for files newer than ...
//   added new hotkey - to condense mode.
// 1.03 - 19-Aug-93 00:09am
//   corrected minor bug in scr.updating in FREQ window
//   added possibily to change file-srch-string
//
// --------------------------------------------------------------------

prototype CRE_FREQ {
    int CRE_FREQ (str fname, tname, faddr, taddr, path) ;
}

prototype GET_F_PARM {
    int GET_F_PARM(int dflt);
}


#define YF_FW_HEI 5


// Converts the string into word value
/* ------------------------------------------------- */
      int str2word(str ss)
/* ------------------------------------------------- */
{ int ii = 0;

  ii = ascii(copy(ss,1,1)) + (ascii(copy(ss,2,1)) << 8);
  return (ii);
}


// Converts the string into word value into 2 bytes string
/* ------------------------------------------------- */
      str long2str(int ii)
/* ------------------------------------------------- */
{
  return ( char(ii&$FF) + char(ii>>8) +
    char(ii>>16) + char(ii>>24));
}


// Converts the string into word value
/* ------------------------------------------------- */
      int str2long(str ss)
/* ------------------------------------------------- */
{ int ii;

  ii = ascii(copy(ss,1,1)) + (ascii(copy(ss,2,1)) << 8) +
       (ascii(copy(ss,3,1)) << 16) + (ascii(copy(ss,4,1)) << 24);
  return (ii);
}


// Converts the string into word value into 2 bytes string
/* ------------------------------------------------- */
      str word2str(int ii)
/* ------------------------------------------------- */
{
  return ( char(ii&$FF) + char(ii>>8) );
}


/* ------------------------------------------------- */
        int mark_found_str(str s1)
/* ------------------------------------------------- */
{
    col_block_begin;
    if ( s1 == '' )
        goto_col( c_col + length(found_str) - 1);
    else
        goto_col( c_col + length(s1) - 1);

    block_end;
    return ( 1 );
}


// Pads string with zeroes where 1st found
/* ------------------------------------------------- */
      str pad_nulstr( str ss, int ml )
/* ------------------------------------------------- */
{ int ii;
  str ss1[200];

  if ( (ii=xpos(char(0),ss,1)) != 0 ) {
    ss1 = copy(ss,1,ii);
    pad_str(ss1, ml, char(0));
  }
  else ss1 = ss;

  return ( ss1 );
}


//
//  Trying to move cursor line either to upper or lower
//  end-of-screen. Not at center.
//
/* ------------------------------------------------- */
        int uncenter_line()
/* ------------------------------------------------- */
{   int ii, jj, kk, half, l1, orf;

    orf = refresh;
    refresh = 0;

    half = ((Win_Y2 - Win_Y1) / 2);
    ii = C_Row - half ;

    kk = c_row;
    if ( ii >= 0 ) {    // At bottom
        jj = (win_y2 - win_y1 + 1) - c_row - 4;
    }
    else {              // At top
        jj = c_row - 3;
    }

    l1 = jj;
    if ( jj < 0 ) l1 = -jj;

    if ( ii * jj > 0 ) {
        for ( kk=0; kk<l1; kk++ ) {
            Goto_Line(C_Line - 1);      // scroll Up
        }
    }
    else {
        for ( kk=0; kk<l1; kk++ ) {
            Goto_Line(C_Line + 1);      // scroll Dn
        }
    }

    //new_screen;
    refresh = orf;
    return ( 1 );
}


/* ------------------------------------------------- */
        int save_key(int k1, int k2) {
/* ------------------------------------------------- */
int ii;
str ss, s1, kk;

    s1 = global_str('!YFREQ_KEYSTS');
    ii = inq_key(k1,k2,Edit,ss);

    kk = str(k1)+str(k2)+'=';
    s1 += 'K' + kk + str(ii);
    if ( ii==1 ) {
        s1 += 'M' + kk + ss;
    }
    else if ( ii>255 ) {
        s1 += 'C' + kk + str( (ii & $FF) );
    }

    set_global_str('!YFREQ_KEYSTS',s1);
    return ( 0 );
}



/* ------------------------------------------------- */
        int restore_key(int k1, int k2) {
/* ------------------------------------------------- */
int ii, jj;
str ss, s1, kk;

    s1 = global_str('!YFREQ_KEYSTS');
    kk = str(k1)+str(k2)+'=';

    jj = parse_int( 'K'+kk, s1);

    if ( jj==1 ) {
        ss = parse_str( 'M'+kk, s1);
        macro_to_key( ((k2<<8)|k1), ss, Edit );
    }
    else if ( jj>255 ) {
        ii = parse_int( 'C'+kk, s1);
        cmd_to_key(((k2<<8)|k1), ii, Edit);
    }
    // Corrected by Vadim Petrjaev
    else if (jj==0)
        unassign_key( ((k2<<8)|k1), Edit);

    return ( 0 );
}


//
//  Checks if request buffer exist. If 'flag' > 0 switches to it.
//  Var 'oldw' gets the value of original window ID (where was started).
//  Returns: 0 - no buf, 1 - exist but empty, 2 - there are files in it
//
/* ------------------------------------------------- */
            int chk_reqbuf(int flag,int& oldw)
/* ------------------------------------------------- */
{   int ii, jj, cw, stat=0, orf;

    cw = cur_window;
    orf = refresh ;
    refresh = 0;

    oldw = parse_int( '/OW=',global_str('!YFREQ_REQID'));

    if ( (ii = parse_int( '/W=',global_str('!YFREQ_REQID'))) != 0 ) {
      if ( (stat = switch_win_id( ii )) != 0 ) {
          mark_pos;
          tof;
          if ( Not(At_eof) ) stat = 2;
          goto_mark;
      }
    }

    if ( flag == 0 ) switch_window( cw );

    refresh = orf;
    return ( stat );
}


/* ------------------------------------------------------------

 NAME:         REST_W_SIZE

 DESCRIPTION:  Restores size of window

 PARAMETERS:   s1 - saved params, id - ID of modified window

-------------------- 25-Oct-93 02:46pm ---------------------- */
int REST_W_SIZE(str s1,int id)
{   int ow, y2, slen, ii;
    ow = cur_window;

    if ( (slen = parse_int('/SCR=',s1)) != screen_length ) {
      switch ( slen ) {
        case  25: ii=0; break;
        case  33: ii=1; break;
        default:  ii=2; break;
      }
      RM('SETUP^TGLVID /M='+str(ii));
    }

    if ( xpos('/ID'+str(id),s1,1) != 0 ) {
        switch_win_id( id );
        y2 = parse_int('/Y'+str(id)+'=',s1);
        size_window(win_x1,win_y1,win_x2,y2);
        // Restore bottom bar if any
        window_attr = parse_int('/WA'+str(id)+'=',s1);
    }
    switch_window( ow );
    return ( 1 );
}


/* ------------------------------------------------------------

 NAME:         DEL_REQ_BUF

 DESCRIPTION:  Deletes FREQ buffer, w/or/wo confirmation
    Moves to window where <CTRL-F> was pressed 1st time.

 RETURNS: 1 if FREQ buffer deleted

-------------------- 25-Oct-93 04:20pm ---------------------- */
    int del_req_buf( int confirm )
{
int ii, old_id, jj, freq_id, orf;
str s1;

  return_int = 0;
  s1 = global_str('!YFREQ_REQID');
  old_id = parse_int('/OW=',s1);
  freq_id = parse_int('/W=',s1);
  orf = refresh;
  refresh = 0;

  if ( (confirm>0) && (chk_reqbuf(0,ii)==2) ) {
      Return_Str = 'Y';
      RM("USERIN^QUERYBOX /W=1/T=FREQ buffer not empty!:/P=Delete it?/C=3/L=6");
      if ( (return_int == 0) || ( caps(return_str) != 'Y')  )  {
        return_int = 0;
        goto ex;
      }
  }

  if ( switch_win_id( freq_id ) ) {
    delete_window;
    set_global_str('!YFREQ_REQID','');
    set_global_int('!YFREQ_TSIZE',0);
    rest_w_size(s1,old_id);
    return_int = 1;
  }

  switch_win_id( old_id );
ex:
  refresh = orf;
  return ( return_int );
}

/* ------------------------------------------------------------

 NAME:         CORR_WIND

 DESCRIPTION:  Corrects sizes of current and FREQ windows

-------------------- 16-Aug-93 02:19pm ---------------------- */
macro CORR_WIND {
int fid, cw, ii, orf, y2, yscr;

    orf = refresh ;
    refresh = 0;

    cw = cur_window;
    fid = parse_int('/W=',global_str('!YFREQ_REQID'));
    y2 = parse_int('/Y'+str(window_id)+'=',global_str('!YFREQ_REQID'));
    yscr = parse_int('/SCR=',global_str('!YFREQ_REQID'));

    if ( yscr != screen_length ) {  // if screen len changed
        y2 = screen_length + (y2 - yscr);
    }

    switch_win_id( fid );
    // If user played with windows - correct
    if ( win_y1 != (y2-YF_FW_HEI) ) {
        size_window(win_x1,y2-YF_FW_HEI,win_x2,y2);
        //w_bottom_line = 1;
    }

    switch_window( cw );

    if ( win_y2 != (y2-YF_FW_HEI) ) {
        size_window(win_x1,win_y1,win_x2,y2-YF_FW_HEI);
    }
ex:
    refresh = orf;
    new_screen;
}


/* ------------------------------------------------------------

 NAME:         MAKE_FREQ_WIN

 DESCRIPTION:  Makes the FREQ window, corrects sizes of adjacent ones
      If request from new window saves its params in global

  RETURNS: 0 if FREQ buffer was killed due to change of window,
      1 - otherwise.

-------------------- 21-Jul-93 10:08pm ---------------------- */
int make_freq_win(int dummy)
{   str s1[128];
    int fexist, ii, aid, ow, owa, orf, x1, y1, x2, y2,
        oy2, ny2, cw;

    y2 = win_y2;
    cw = window_id;
    s1 = global_str('!YFREQ_REQID');

    // dummy=1 - not to check for FREQ window
    if ( (dummy > 0) ) goto ex2;
    else if ( (fexist = chk_reqbuf(0,aid)) > 0 ) goto ex2;

    orf = refresh;
    refresh = 0;

    ow = cur_window;
    create_window;

    if ( error_level ) {
        RM("MEERROR^MESSAGEBOX /B=3/M=Can't create REQUEST window");
        goto ex;
    }

    s1 = '/OW='+str(cw);
    aid = window_id;
    file_name = '!FREQ.0';
    // cw - old window, aid - FREQ window
    switch_win_id( cw );
    refresh = orf;

    s1 += '/W='+str(aid) + '/SCR='+str(screen_length) +
          '/SRCH=% *?+.?+ +' ;
    rm("WINDOW^SplitWin /DIR=DOWN/LN#=" + str(YF_FW_HEI) +
        "/ID=" + str(aid));

    s1 += '/ID'+str(cw)+'/Y'+str(cw)+'='+str(y2)+
    '/WA'+str(cw)+'='+str(window_attr);
    set_global_str('!YFREQ_REQID',s1);
    goto ex4;
ex2:
    // Check if window not matches one where FREQ buf created
    if ( xpos('/ID'+str(cw),s1,1) == 0 ) {  // New window
        if ( del_req_buf( fexist > 1 ) > 0 )
          switch_win_id(cw);
        goto ex5;
    }
ex3:
    RM('YFREQ^CORR_WIND');
ex:
    refresh = orf;
    new_screen;
ex4:
    if ( block_stat ) block_off;
    return ( 1 );
ex5:
    return ( 0 );
}


/* ------------------------------------------------------------

 NAME:         YFstart

 DESCRIPTION:  Prepares FREQ system, sets keys and globals

 PARAMETERS:

 RETURNS:

-------------------- 21-Jul-93 10:08pm ---------------------- */
macro YFstart {
int ii, owa ;
str tmppath;

    if ( global_str('!YFREQ_KEYSTS') != '') {
      RM('MEERROR^MESSAGEBOX /T=YFREQ-Error/M=Already installed!/B=1');
      goto ex;
    }

    RM('YARCDIR^YARC_SETUP');

    // Put here name of path to *.MSG
    set_global_str('!YFREQ_PATH',YF_S_MSGDIR);

    // Default attributes
    set_global_int('!YFREQ_FATTR',YF_S_FATTR);

    save_key(6,33);  // <CtrlF>
    macro_to_key(<CtrlF>,'YFREQ^GET_FILE',edit);

    save_key(253,33);   // <CtrlShftF>
    macro_to_key(<CtrlShftF>,'YFREQ^YF_MENU',edit);

    save_key(0,33);   // <AltF>
    macro_to_key(<AltF>,'YFREQ^YF_GEN_FREQ',edit);  // <CtrlF>

    save_key(0,107);    // <AltF4>
    macro_to_key(<AltF4>,'YFREQ^Freq_Cond',edit);

    save_key(YF_S_LDKEY1,YF_S_LDKEY2);    // <Shft-F3> by default
    macro_to_key((YF_S_LDKEY2<<8)|YF_S_LDKEY1,
      'YARCDIR^YARCDIR '+YF_S_LSTDIR,edit);

    make_message( '<CTRL-F>-File, <ALT-F>-GEN FREQ,<CTRL-Shft-F>-Menu' );
    beep;

    if ( block_stat ) block_off;
ex:
}


/* ------------------------------------------------------------

    Expanding name macros (&A,&F,&O)

   ------------------------------------------------------------ */
    int parse_cmd(str& cmd,str mcro,str repl)
{
    int ii, jj;

    if ( (ii = xpos(mcro,cmd,1)) > 0 ) {
        cmd = str_del(cmd,ii,length(mcro));
        cmd = str_ins(repl,cmd,ii);
        return ( 1 );
    }
    else return ( 0 );
}

/*---------------11-15-93 06:19pm-------------------

 DESCRIPTION:  Macro to call YARCDIR from menu - discards
    the unnecessary options.

--------------------------------------------------*/
Macro YARC1 {
int ii;
str param[90] = mparm_str;

  if ( (ii=xpos(' ',param,1)) > 0 ) {
    param = copy(param,1,ii-1);
  }
  RM('YARCDIR '+param);
}


/* ------------------------------------------------------------

 NAME:         YF_MENU

 DESCRIPTION:  Main menu of YFREQ system

 PARAMETERS:

 RETURNS:

-------------------- 30-Jul-93 11:42pm ---------------------- */
macro YF_MENU {
int ii, jj, kk;
int menu = menu_create ;
str s1[80] ;

    menu_set_item(menu,1,"Uninstall","","/M=YFREQ^YFend",0,0,0);
    menu_set_item(menu,2,"fLags","","/M=YFREQ^YF_FLAGS",0,0,0);
    menu_set_item(menu,3,"gen-FREQ","","/M=YFREQ^YF_GEN_FREQ",0,0,0);
    menu_set_item(menu,4,"Mode","","/M=YFREQ^FILE_MODE",0,0,0);
    menu_set_item(menu,5,"Attach","","/M=YFREQ^YF_GEN_ATT",0,0,0);
    menu_set_item(menu,6,"Srch-dflt","","/M=YFREQ^YF_GETSDFLT",0,0,0);
    menu_set_item(menu,7,"lisT","","/M=YFREQ^YF_GETFLIST",0,0,0);
    menu_set_item(menu,8,"lOad","",'/M=YFREQ^YARC1 '+YF_S_LSTDIR,0,0,0);
    menu_set_item(menu,9,"Exit","","",0,0,0);

	Return_Int = menu;
    RM("USERIN^TOPMENU /HN=1/#=9/X=1/Y=2/S=2/BC=1/L="+ YF_S_NAME);

ex:
    menu_delete( menu );
}


/* ------------------------------------------------------------

 NAME:         YF_FLAGS

 DESCRIPTION:  Modifies the default flags for generated FREQs

 PARAMETERS:   /F = filespec
               /LOC=1   if specified - local flags,
                        otherwise - global(default) flags changing.
               /A = attributes, if not specified using global
 RETURNS:

-------------------- 30-Jul-93 11:50pm ---------------------- */
macro YF_FLAGS {
int ii, flags, menu = menu_create, nn=13, loc=0 ;
int i1, i2, i3;
str files[80];

    files = remove_space( parse_str('/F=',mparm_str) ) ;
    loc = parse_int('/LOC=',mparm_str);

    if ( (flags = parse_int('/A=',mparm_str)) == 0 ) {
        flags = global_int( '!YFREQ_FATTR');
    }

    if ( (ii=xpos(char(0),files,1)) > 1 ) {
      files = copy(files,1,ii-1) ;
    }

    menu_set_item(menu,1,"Freq flags:","","/QK=1/L=1/C=4",10,0,0);
    menu_set_item(menu,2,"Private   ","","/L=2/C=2",13,(flags & MA_Private)!=0,0);
    menu_set_item(menu,3,"Crash     ","","/L=3/C=2",13,(flags & MA_Crash)!=0,0);
    menu_set_item(menu,4,"Sent      ","","/L=4/C=2",13,(flags & MA_Sent)!=0,0);
    menu_set_item(menu,5,"Kill Sent ","","/L=5/C=2",13,(flags & MA_KillSent)!=0,0);
    menu_set_item(menu,6,"Local     ","","/L=2/C=20",13,(flags & MA_Local)!=0,0);
    menu_set_item(menu,7,"RRP       ","","/L=3/C=20",13,(flags & MA_RetRecptReq)!=0,0);
    menu_set_item(menu,8,"IRR       ","","/L=4/C=20",13,(flags & MA_IsRetReceipt)!=0,0);
    menu_set_item(menu,9,"Hold      ","","/L=5/C=20",13,(flags & MA_Hold)!=0,0);
    menu_set_item(menu,10,"Direct    ","","/L=2/C=40",13,(flags & MA_Direct)!=0,0);
    menu_set_item(menu,11,"fPu       ","","/L=3/C=40",13,(flags & MA_FPU)!=0,0);
    menu_set_item(menu,12,"Attach    ","","/L=4/C=40",13,(flags & MA_FileAtt)!=0,0);
    menu_set_item(menu,13,"Request   ","","/L=5/C=40",13,(flags & MA_FileReq)!=0,0);

    if ( files != '' ) {
        menu_set_item(menu,++nn,"Files:",files,"/QK=1/W=50/ML=72/L=7/C=2",
            0,0,0);
    }

    Return_Int = menu;
    RM("USERIN^DATA_IN /HN=1/PRE=EX/#=" + str(nn) + "/T=Freq MSG Flags");
    ii = return_int;

    flags = (menu_item_int(menu,2,2)*MA_Private) +
            (menu_item_int(menu,3,2)*MA_Crash) +
            (menu_item_int(menu,4,2)*MA_Sent) +
            (menu_item_int(menu,5,2)*MA_KillSent) +
            (menu_item_int(menu,6,2)*MA_Local) +
            (menu_item_int(menu,7,2)*MA_RetRecptReq) +
            (menu_item_int(menu,8,2)*MA_IsRetReceipt) +
            (menu_item_int(menu,9,2)*MA_Hold) +
            (menu_item_int(menu,10,2)*MA_Direct) +
            (menu_item_int(menu,11,2)*MA_FPU) +
            (menu_item_int(menu,12,2)*MA_FileAtt) +
            (menu_item_int(menu,13,2)*MA_FileReq) ;

    //if ( (flags & MA_FileAtt) == 0 )  flags += MA_FileReq;

    files = remove_space( caps( menu_item_str(menu,nn,2) ) );
    if ( length(files) > 0 ) {
      pad_str(files,71,' ');
      files += char(0);
    }
    return_str = files;

    if ( loc==0 )
      set_global_int( '!YFREQ_FATTR',flags);
ex:
    menu_delete( menu) ;
    return_int = flags;
}


macro FILE_MODE {
    rm('meerror^messagebox /B=2/M=Not done yet!');
}


/* ------------------------------------------------------------

 NAME:         YF_GETSDFLT

 DESCRIPTION:  Interface to main parameters

 PARAMETERS:

 RETURNS:

-------------------- 19-Aug-93 00:17am ---------------------- */
macro YF_GETSDFLT {
int ii, jj, n1, len, menu = menu_create ;
str ss[40], ss1[128];

    ss1 = global_str('!YFREQ_REQID');
    ss = parse_str('/SRCH=',ss1);
    len = svl(ss);
    n1 = xpos('/SRCH=',ss1,1);

    menu_set_item(menu,1,"Filespec search string:",ss,"/QK=1/W=20/ML=19/L=1/C=2",
            0,0,0);
	Return_Int = menu;
    RM("USERIN^DATA_IN /HN=1/#=1/T=Freq Defaults");
    if ( (return_int > 0) && (n1>0) ) {
        ss = menu_item_str(menu,1,2);
        ss1 = str_del(ss1,n1+6,len) + ss;
        set_global_str('!YFREQ_REQID',ss1);
    }
ex:
    menu_delete( menu );
}

/* ------------------------------------------------------------

 NAME:         YFEND

 DESCRIPTION:  Clean up request session.

 PARAMETERS:

 RETURNS:

-------------------- 29-Jul-93 09:35pm ---------------------- */
macro YFEND {
int x1, y1, x2, y2, cw, ii, id, ow = -1, y2 ;
str s1[300], s2[60];

    if ( chk_reqbuf(0,ow) > 0 )    {
        if ( del_req_buf( chk_reqbuf(1,ow) > 1 ) == 0 )
          goto ex3;
    }

ex1:
    if ( global_str('!YFREQ_KEYSTS') == '' )
        goto no_keys; // Impossible?

    restore_key(6,33);  // <CtrlF>
    restore_key(253,33);   // <CtrlShftF>
    restore_key(0,33);   // <AltF>
    restore_key(0,107);  // <AltF4>
    restore_key(YF_S_LDKEY1,YF_S_LDKEY2);    // <Shft-F3> by default

no_keys:
    set_global_str('!YFREQ_TADDR','');
    set_global_str('!YFREQ_TNAME','');

    set_global_str('!YFREQ_REQID','');
    set_global_str('!YFREQ_KEYSTS','');
    set_global_str('!YFREQ_PATH','');

    make_message( 'FREQ uninstalled!' );
    beep;
ex:
    RM('YARCDIR^YARC_end');
    set_global_int('!YFREQ_TSIZE',0);
    if ( ow > 0 ) switch_win_id( ow );
ex3:
    new_screen;
}

/* ------------------------------------------------------------

 NAME:         CORR_ADDR

 DESCRIPTION:  Fills NET & ZONE in address if empty from address
    of user ( YF_S_FROMADDR ).

 PARAMETERS:   address to correct

 RETURNS:      corrected address
-------------------- 24-Oct-93 01:37pm ---------------------- */
str corr_addr( str addr )
{ int ii, jj;
  str zone[10], net[20];

  zone = copy(YF_S_FROMADDR,1,xpos(':',YF_S_FROMADDR,1));
  net  = copy(YF_S_FROMADDR,svl(zone)+1,xpos('/',YF_S_FROMADDR,1)-svl(zone));

  if ( xpos('/',addr,1) == 0 ) {
    addr = net + addr;
  }
  if ( xpos(':',addr,1) == 0 ) {
    addr = zone + addr;
  }

  return ( addr );
}

/* ------------------------------------------------------------

 NAME:         GET_ADDR

 DESCRIPTION:  Selecting the name & address of node to request
    files from.

 PARAMETERS:

 RETURNS:      Sets global and returns 1 if OK.

-------------------- 29-Jul-93 02:38pm ---------------------- */
            macro GET_ADDR {
/* ---------------------------------------------------------- */
int ii, jj, c1, orf, maxlines, cw, aw, rw, y;
int stat = 1, menu = menu_create, fline=0;
str addr[20], name[60];

    cw = cur_window;
    orf = refresh;
    refresh = 0;
    mark_pos;

    // Window for user_in
    create_window;
    if ( error_level ) {
        make_message( "Can't create window..." );
        beep;
        stat = 0;
        goto ex;
    }

    aw = window_id;
    switch_window( cw );

    tof;
    maxlines = 40;
    ii = 0;
    while ( maxlines > 0 ) {
        if ( Find_text(' [0-9]+:[0-9]+/[0-9]+[.0-9]*',maxlines,
            _RegExp | _OldExp) ) {

            if ( fline == 0 ) // Save 1st found line
                fline = c_line;

            addr = copy(found_str,2,99);
            maxlines = 40 - c_line;
            ii++;
            right;
            switch_win_id( aw );
            put_line( addr );
            eol; cr;
            switch_window( cw );
        }
        else break;
    }

    if ( ii ) {
        refresh = 1;
        goto_line( fline ); goto_col(1);
        Find_text(' [0-9]+:[0-9]+/[0-9]+[.0-9]*',maxlines,_RegExp|_OldExp);
        mark_found_str('');
        uncenter_line();
        new_screen;

        y = win_y2 - 12;
        if ( c_row > 8 ) y = 2;
        refresh = 0;

        switch_win_id( aw );
        tof;
        menu_set_item(menu,1,"ADDRESS:","","/L=1/C=5/DC=1/W=15/WIN=" +
            str(cur_window) ,15,0,0);
        Return_Int = menu;
        RM("USERIN^DATA_IN /HN=1/A=2/PRE=V/#=1/DBL=1/T=FIDO ADDR/X=10"+
            "/Y="+str(y) );
        if ( return_int ) addr = get_line;
        else {
            addr = '';
            stat = 0;
        }
    }

    if ( switch_win_id( aw ) ) {
        file_changed = 0;
        delete_window;
    }

    switch_window( cw );
    set_global_str('!YFREQ_TADDR',addr);

    // Trying to find a name
    tof;
    refresh = 1;
    if ( ( stat != 0 ) &&
         ( find_text('{sysops*?}||{system *operator}',30,_RegExp | _OldExp ) != 0 )
        ) {
        goto_col( c_col + length(found_str) );
        find_text('[~A-Za-z--_]*:*[~A-Za-z--_]*',30,_RegExp | _OldExp );
        goto_col( c_col + length(found_str) );
        if ( find_text('[a-zA-Z--_. ]+',1,_RegExp | _OldExp )) {
            mark_found_str('');
            uncenter_line();
            new_screen;

            y = win_y2 - 12;
            if ( c_row > 8 ) y = 2;

            Return_Str = remove_space( found_str );
            RM("USERIN^QUERYBOX /W=20/P=Get this name?:/T=TO name/C=3/L="+str(y));
            if ( return_int  ) set_global_str('!YFREQ_TNAME', return_str);
            block_off;
        }
    }

ex:
    menu_delete( menu );
    switch_window( cw );
    goto_mark;
    refresh = orf;
    return_int = stat;
}



/* ------------------------------------------------------------

 NAME:         GET_NAME

 DESCRIPTION:  Seeking for the TOname in FIDOUSER.LST file.
               Address must be known before.

 PARAMETERS:

 RETURNS:      Sets global and returns 1 if OK.

-------------------- 29-Jul-93 02:38pm ---------------------- */
            macro GET_NAME {
/* ---------------------------------------------------------- */
int ii, jj, c1, orf, maxlines, cw, aw, fw;
int stat = 1, menu = menu_create;
str name[60] = '', addr[20], fname[30], tmpname;

    if ( global_str('!YFREQ_TADDR') == '' ) {
        make_message( 'Address must be set before!' );
        stat = 0;
        goto ex1;
    }

    if ( file_exists(YF_S_FIDOLIST) == 0 ) {
        make_message( 'File FIDOUSER.LST not found! ');
        stat = 0;
        goto ex1;
    }

    aw = fw = -1;
    cw = cur_window;
    orf = refresh;
    refresh = 0;
    mark_pos;

    create_window;
    if ( error_level ) {
        make_message( "Can't create window..." );
        beep;
        stat = 0;
        goto ex;
    }
    aw = cur_window;

    create_window;
    if ( error_level ) {
        make_message( "Can't create window..." );
        beep;
        stat = 0;
        goto ex;
    }
    fw = cur_window;

    make_message( 'Seeking for "'+global_str('!YFREQ_TADDR')+
        '" ...' );

    tmpname = global_str('@TMP_FILE_PATH');
    if ( tmpname=='' ) tmpname='.\';
    tmpname += 'mefido.tmp';

    return_str = 'Grep -i- -o- '+ global_str('!YFREQ_TADDR') +
        ' ' + YF_S_FIDOLIST + ' >' + tmpname ;

    // To GREP only 150K now
    RM('MEUTIL1^EXEC /SCREEN=3/RED=NUL/MEM='+str(150*64));

    load_file( tmpname );
    ii = 0;
    while ( Not(At_Eof) ) {
        if ( Find_text(global_str('!YFREQ_TADDR'),0,
            _RegExp | _OldExp | _CaseSensitive) ) {
            eol;
            name = remove_space( get_line );
            call p_get_addr;
            call p_get_name;
            ii++;
            eol;
            switch_window( aw );
            put_line( addr + ' || ' + name );
            eol; cr;
            switch_window( fw );
        }
        else break;
    }

    if ( fw != -1 ) {
        return_int = fw;
        call del_win;
        fw = -1;
    }
    del_file( tmpname );

    if ( ii ) {
        switch_window( aw ); tof;
        ii = Find_text(global_str('!YFREQ_TADDR')+' +',0,
            _RegExp | _OldExp | _CaseSensitive);
        menu_set_item(menu,1,"SysOp Name:","","/L=2/C=2/DC=1/WIN=" + str(aw) ,15,0,0);
        Return_Int = menu;
        RM("USERIN^DATA_IN /HN=1/A=2/PRE=V/#=1/DBL=1/T=NAME");
        if ( return_int ) {
            name = get_line;
            ii = xpos(' || ',name,1);
            name = copy(name,ii+3,99);
        }
        else name = '';
    }
    else make_message( 'Address not found.' );

    set_global_str('!YFREQ_TNAME',name);
    stat = (name != '');
    goto ex;

del_win:
    if ( return_int != -1 ) {
        switch_window( return_int );
        file_changed = 0;
        delete_window;
    }
    RET;

p_get_addr:
    for ( ii=svl(name); ii>1; ii-- ) {
        if ( copy(name,ii,1) == ' ' ) break;
    }
    addr = copy(name,ii+1,99);
    pad_str(addr,15,' ');
    name = remove_space(copy(name,1,ii));
    RET;

p_get_name:
    if ( (ii = xpos(',',name,1)) == 0 ) RET;
    fname = remove_space( copy(name,ii+1,99) );
    name = fname + ' ' + remove_space( copy(name,1,ii-1) ) ;
    RET;

ex:
    if ( fw != -1 ) {
        return_int = fw;
        call del_win;
    }

    if ( aw != -1 ) {
        return_int = aw;
        call del_win;
    }

    menu_delete( menu );
    switch_window( cw );
    goto_mark;
    refresh = orf;
ex1:
    return_int = stat;
}



/* ------------------------------------------------------------

 NAME:         find1st_msg

 DESCRIPTION:  Finds the 1st number >= any of *.MSG files to be used
    for newly created message.

 PARAMETERS:   FileNAME to be used

 RETURNS:      Message-file number

-------------------- 21-Jul-93 04:18pm ---------------------- */
    int find1st_msg (str path,str& filnam) TRANS {
/* ---------------------------------------------------------- */
    int ii, jj, sts, num;
    str tstr;

    filnam = '';
    num=0;

    file_search_attr = 0;
    if ( (sts = first_file(path+'*.MSG')) != 0 )
        goto ex;

    while ( sts == 0 ) {
        tstr = last_file_name;
        ii = xpos('.',tstr,1);
        tstr = copy(tstr,1,ii-1);
        val(jj,tstr);
        if ( jj > num ) num = jj;

        sts = next_file;
    }

ex:
    return (num + 1);
}


/* ------------------------------------------------------------

 NAME:         chk_msg

 DESCRIPTION:  checks if FIDO message specified by name is FREQ/ATTACH
    Returns "To" and "Subj" in strings.

 RETURNS: '?' if message not FREQ nor ATTACH, otherwise 'F' or 'A'.

-------------------- 11-Oct-93 12:42pm ---------------------- */
str chk_msg(str fname,int& attr,str& To,str& Flist,str& toaddr)
{ int ii, jj, att, hh, toa, tonet;
  str buf[200], buf1[100];
  char sts = '?';

  if ( s_open_file(fname,$40,hh) != 0 ) return (sts);
  if ( s_read_bytes(buf,hh,190) !=0  )  goto bad_ex;
  s_read_bytes(buf1,hh,99);
  s_close_file(hh);

  attr = att = str2word( copy(buf,187,2) );
  toa = str2word( copy(buf,167,2) );    // destnode
  tonet = str2word( copy(buf,173,2) );  // destnet
  toaddr = str(tonet)+'/'+str(toa) ;

  if ( (ii=xpos('FLAGS DIR',buf1,1)) != 0 ) attr |= MA_Direct;
  if ( (ii=xpos('FLAGS FPU',buf1,1)) != 0 ) attr |= MA_FPU;

  if ( (ii=xpos('TOPT ',buf1,1)) != 0 ) {
      jj = val(toa,copy(buf1,ii+5,99));
      if ( jj ) {
          jj = val(toa,copy(buf1,ii+5,jj-1));
          if ( jj ) {
            toaddr += '.?';
          }
          else toaddr += '.' + str(toa);
      }
  }

  if ( (att & MA_FileReq) !=0 ) sts = 'F';
  if ( (att & MA_FileAtt) !=0 ) sts = 'A';

  if (sts == '?') {
  bad_ex:
    s_close_file(hh);
    return ( sts );
  }

  // Some messages created by stupid editors!
  To = pad_nulstr( copy(buf,37,36), 36 );
  Flist = pad_nulstr( copy(buf,73,72), 72 );
  return (sts);
}


/* ------------------------------------------------------------

 NAME:         FORCE_RESCAN

 DESCRIPTION:  Creates RESCAN semaphore.

 PARAMETERS:   Name of semaphore.

 RETURNS:

-------------------- 19-Sep-93 02:54pm ---------------------- */
void force_rescan (str fname) {
int ii, jj;

    if ( file_exists(fname) ) {
        del_file( fname );
    }
    jj = s_create_file( fname, ii);
    s_close_file( ii );
}

// Editing message file ( Currently only flags and Subj !)
// Returns 0 if OK.
/* ----------------------------------------------------------------- */
 int chg_msg(str fname,int oattr,int attr,str To,str Flist,str toaddr)
/* ----------------------------------------------------------------- */
{ int ii, jj, att, hh, toa, tonet;
  str buf[200], buf1[100], sattr[2];
  int sts = -1, attr1;

  if ( (attr&(MA_Direct+MA_FPU)) != (oattr&(MA_Direct+MA_FPU)) ) {
    make_message( 'Kludge change not supported now!' );
    beep; delay(1000);
  }

  if ( s_open_file(fname,1,hh) != 0 ) goto wr_err;
  attr &= $FFFF;

  if ( attr == oattr ) goto ex1;

  if ( s_move_file_ptr(hh,0,186) != 0 ) goto wr_err;
  sattr = word2str( attr );
  ii=2;
  if ( s_write_bytes(sattr,hh,ii) != 0 ) goto wr_err;
  call cre_smph;

ex1:
  if ( Flist == '' ) goto ex;
  if ( s_move_file_ptr(hh,0,72) != 0 ) goto wr_err;
  ii = 72;
  Flist = pad_nulstr( Flist, 72 );
  if ( s_write_bytes(Flist,hh,ii ) != 0 ) goto wr_err;
  call cre_smph;
  goto ex;

cre_smph:
#ifdef YF_S_RESCAN
    beep;
    force_rescan(YF_S_RESCAN);
#endif
    ret;

ex:
  s_close_file(hh);
  return ( 0 );
wr_err:
  make_message( 'Error!' ); beep;
  return ( -1 );
}


/* ------------------------------------------------------------

 NAME:         chk2semaphores

 DESCRIPTION:  Checks if semaphore files which disallow to create
      *.MSG file are exist. If so waits a little and checks again.
      Creates YF_S_WSEMAPHORE.

 PARAMETERS:   'path' - NETMAIL path

 RETURNS:      If no success returns non-zero

-------------------- 04-Nov-93 08:17pm ---------------------- */
              int chk2semaphores () {
/* ---------------------------------------------------------- */
    int ntries=0, ii, sts=1, wi=0;
    str cname[40], path;

    file_search_attr = 0;
    path = get_path( YF_S_RESCAN );
try_lab:
    if ( first_file(path+'FDRENUM.*') == 0 ) {
        cname = 'FDRENUM.*';
        goto wait;
    }
    if ( first_file(path+'FDSCAN.*') == 0 ) {
        cname = 'FDSCAN.*';
        goto wait;
    }

    sts = s_create_file( path+YF_S_WSEMAPHORE, ii);
    s_close_file( ii );
    make_message( 'FD semaphore created...' );
    goto ex;

wait:
    if ( wi<YF_I_WAITT ) {
        if ( wi == 0 )
          put_box( 12,5,58,8,M_T_COLOR >> 4,M_T_COLOR & $F,
          "Waiting for NETMAIL semaphores "+cname, 1);

        write( 'Time left: '+ str(YF_I_WAITT-wi) + ' ',
          26,6,W_T_COLOR>>4,W_T_COLOR & $F);

        wi++;
        delay(1000);
        if ( check_key ) {
          make_message( 'Interrupted by user...' ); beep;
          goto ex;
        }
        goto try_lab;
    }
    else {
        kill_box;
        RM('MEERROR^MESSAGEBOX /T=YFREQ/M='+
          'Seems that NETMAIL directory is locked. You can delete '+
          'FDRESCAN.*, FDRENUM.* semaphore files manually or try to '+
          'generate FREQ message again...');
        wi = 0;
    }

ex:
    if ( wi > 0 ) kill_box;
    return ( sts );
}



/* ------------------------------------------------------------

 NAME:         clr_semaphore

 DESCRIPTION:  Removes previously created semaphore file YF_S_WSEMAPHORE

 PARAMETERS:   'path' - NETMAIL path

 RETURNS:      0 - if OK

-------------------- 04-Nov-93 08:47pm ---------------------- */
          int clr_semaphore () {
/* ---------------------------------------------------------- */
int sts = 1;
str cname[40], path;

    path = get_path( YF_S_RESCAN );
    file_search_attr = 0;

    if ( file_exists(path+YF_S_WSEMAPHORE) == 1 ) {
        sts = 0;
        cname = 'FDRENUM.*';
        del_file( path + 'FDRENUM.000');
        return ( error_level );
    }

    return ( sts );
}

/* ------------------------------------------------------------

 NAME:         mk_msglist

 DESCRIPTION:  Creates list of all FREQ/ATTACH messages

 PARAMETERS:   Message path

 RETURNS:

-------------------- 11-Oct-93 12:42pm ---------------------- */
    int mk_msglist (str path=parse_str("/P=",mparm_str) ) TRANS {
/* ---------------------------------------------------------- */
    int ii, jj, sts, nn=0, cts, alldone, el, _line=1;
    int attr, orf, ow, list_id = -1, menu;
    str fname[60], To[40], Flist[80],
        Toaddr[20], ss[200], ss1[80], cname[80];
    char freq_att ;

    ow = window_id;
    orf = refresh;
    refresh = 0;

mk_list:
    alldone = 1;
    menu = menu_create;

    file_search_attr = 0;
    create_window;
    if ( error_level ) {
        RM("MEERROR^MESSAGEBOX /B=3/M=Can't create REQLIST window");
        goto ex;
    }
    list_id = cur_window;
    file_name = 'FREQLIST.0';
    window_attr = $80;

    make_message( 'Creating FREQ list...' );
    working;
    if ( (cts = chk2semaphores()) != 0 ) goto ex;

    if ( (sts = first_file(path+'*.MSG')) != 0 )
        goto ex;

    while ( sts == 0 ) {
        fname = last_file_name;
        ii = xpos('.',fname,1);
        val(jj,copy(fname,1,ii-1));
        if ( (freq_att = chk_msg(path+fname,attr,To,Flist,ToAddr)) != '?' ) {
          goto_col(1);  fname = str(jj);
          while ( svl(fname) < 4 ) fname = '0' + fname;
          text(fname);
          goto_col(6);  text(freq_att);
          goto_col(8);  To = str_ins(ToAddr,To,31-svl(ToAddr));
                        text(copy(To,1,31));
          goto_col(40); text(Flist);
          goto_col(129);text(long2str(attr));
          goto_col(133);text(ToAddr);
          cr;
          ++nn;
        }
        sts = next_file;
    }
    if (cts == 0) clr_semaphore();

    working;
    make_message( 'Sorting...' );
    RM('TEXT^TEXTSORT /C=1/L=4');
    switch_win_id(ow);
    redraw;
    refresh = 0;
    switch_window(list_id);
    make_message( '' );
    goto_line( _line );
once_more:
    menu_set_item(menu,1,".MSG F//A  To-Name             Address   Files ","",
      "/L=3/C=1/DC=1/WIN=" + str(list_id) ,15,0,0);
    menu_set_item( menu, 2, "Delete", "",
      "/KC=<DEL>/K1=0/K2=83/R=11/L=1/C=4/W=0", 11, 0, 0);
    menu_set_item( menu, 3, "Chg.attributes", "",
      "/KC=<F3>/K1=0/K2=61/R=12/L=1/C=18/W=0", 11, 0, 0);
    menu_set_item( menu, 4, "Rename", "",
      "/KC=<F6>/K1=0/K2=64/R=16/L=1/C=40/W=0", 11, 0, 0);
    Return_Int = menu;
    RM('DATA_IN /HN=1/A=2/PRE=V/#=4/DBL=1'+
      '/T=List of FREQ//ATTACH msg');
    if ( return_int == 0 )  goto clean_up;

    ss = get_line;
    attr = str2long( copy(ss,129,4) );
    val(ii,copy(ss,1,4));               // Message No
    cname = path + str(ii) + ".MSG";
    To = copy(ss,8,31);
    Flist = copy(ss,40,72);
    ToAddr = copy(ss,133,20);
    _line = c_line;

    if ( return_int == 11 ) {   // <DEL>
        Return_Str = 'Y';
        RM("USERIN^QUERYBOX /W=1/T=YFREQ - "+ cname +
          "/P=Delete it?/C=3/L=6");
        if ( (return_int == 0) || ( caps(return_str) != 'Y')  )  {
          beep;
          goto once_more;
        }

        if ( (cts = chk2semaphores()) != 0 ) goto clean_up;
        del_file( cname );
        el = error_level;
        clr_semaphore();

        if ( el ) {
            make_message( "Can't delete '"+cname+"'");
            beep;
            goto once_more;
        }
        #ifdef YF_S_RESCAN
            force_rescan(YF_S_RESCAN);
        #endif
        alldone = 0;
    }

    if ( return_int == 12 ) {   // <F3> - Edit
        RM( 'YF_FLAGS /LOC=1/A='+str(attr)+'/F='+Flist );
        if ( (return_int == attr) && (Flist == return_str) ) {
          make_message( 'Nothing changed...' );
          goto once_more;
        }
        Flist = return_str;
        if ( (cts = chk2semaphores()) != 0 ) goto clean_up;
        chg_msg(cname,attr,return_int,To,Flist,ToAddr);
        clr_semaphore();
        alldone = 0;
    }

    if ( return_int == 16 ) {   // <F6> - Rename
        Return_Str = str(ii);
        RM("USERIN^QUERYBOX /W=3/T=YFREQ - "+path+str(ii)+".MSG"+
          "/P=Enter new number:/C=3/L=6");
        val( ii, return_str);
        if ( (return_int == 0) || ( ii <= 0 )  )  {
          make_message( 'Nothing changed...' );
          goto once_more;
        }

        if ( (cts = chk2semaphores()) != 0 ) goto clean_up;
        if ( file_exists( path+str(ii)+".MSG" ) ) {
            make_message( 'File exists, try other No...' );
            goto ren_err;
        }
        if ( COPY_FILE ( cname, path+str(ii)+".MSG",0) == 0 )
            del_file( cname );
        else {
            make_message( "Can't rename '"+cname+"'");
        ren_err:
            clr_semaphore();
            beep;
            goto once_more;
        }
        clr_semaphore();
        #ifdef YF_S_RESCAN
            force_rescan(YF_S_RESCAN);
        #endif
        alldone = 0;
    }

clean_up:
    if ( list_id == cur_window) delete_window;

ex:
  //if (cts == 0) clr_semaphore();
  switch_win_id(ow);
  refresh = orf;
  redraw;
  menu_delete( menu );
  if ( alldone == 0 ) goto mk_list;
  return (0);
}


macro YF_GETFLIST {
  mk_msglist(YF_S_MSGDIR);
}

/* ---------------------------------------- */
        str dtime() TRANS2 {
/* ---------------------------------------- */
    int cm, hour, min;
    str s_year = 'JanFebMarAprMayJunJulAugSepOctNovDec';
    str sss[80], ampm, stime[20], sdate[20];

    sdate = date;
    val(cm,  copy(date,1,2));
    val(hour,copy(time,1,2));
    val(min,copy(time,4,2));
    ampm = copy(time,9,2);

    if ( ampm=='pm' ) hour += 12;
    stime = str(hour) + ':' + str(min) + ':00';

    sss =   copy(sdate,4,2) + ' ' +
            copy(s_year,((cm - 1) * 3) + 1,3) + ' ' +
            copy(sdate,7,2) + '  ' + stime;

    return ( sss ) ;
}


/* --------------------------------------------------- */
    str get_net (str node ) {
/* --------------------------------------------------- */
int ii, jj;
str ss[20];

    if ( (ii = xpos(':',node,1)) == 0 ) ii=0;
    if ( (jj = xpos('/',node,1)) == 0 ) jj=length(node)+1;

    ss = copy(node,ii+1,jj-ii-1);
    val(ii,ss);

    return ( char(ii & $FF) + char(ii >> 8) );
}


/* --------------------------------------------------- */
    str get_node (str node ) {
/* --------------------------------------------------- */
int ii, jj;
str ss[20];


    if ( (ii = xpos('/',node,1)) == 0 ) {ii=0; goto ex;}
    if ( (jj = xpos('.',node,1)) == 0 ) jj = length(node)+1;

    ss = copy(node,ii+1,jj-ii-1);
    val(ii,ss);
ex:
    return ( char(ii & $FF) + char(ii >> 8) );
}

/* --------------------------------------------------- */
            str get_pt(str node) {
/* --------------------------------------------------- */
int ii, jj;
str ss[20];

    if ( (ii = xpos('.',node,1)) == 0 ) {ss=''; goto ex;}

    ss = copy(node,ii+1,99);
ex:
    return ( ss );
}


//
//  Returns: corrected filespec 'files'
//           corrected flags in return_int
//      and string form of flags.
/* --------------------------------------------------- */
        str get_attr (str& files) {
/* --------------------------------------------------- */
int ii, jj;

    ii = global_int('!YFREQ_FATTR');
    RM('YFREQ^YF_FLAGS /LOC=1/F='+files);
    jj = return_int;

    files = return_str;
    return ( word2str( jj ) );
}


/* ------------------------------------------------------------
    Returns 8 chars long UNIX time.
    NOTE: I didn't implement support of timezone, so value not
    ABSOLUTLY correct. But FTS-000? requires for MSGID only to be
    unic.
-------------------- 16-Aug-93 06:19pm ---------------------- */
            str getunixtime()
{
    int x, i, days, hours, tt;
    int da_mon, da_year, da_day, ti_hour, ti_min, ti_sec;
    str DaysS[30] = '312831303130313130313031', ss[80];

    R_AX = $2A00;       // Get DATE
    Intr( $21 );
    da_year = R_CX;
    da_mon =  (R_DX >> 8);
    da_day =  (R_DX & $FF);

    R_AX = $2C00;       // Get TIME
    Intr( $21 );
    ti_hour = (R_CX >> 8);
    ti_min =  (R_CX & $FF);
    ti_sec =  (R_DX >> 8);

    x = 24 * 3600 * 3652 ;   // sec/day
    i = da_year - 1980;          // years since 1980
    x += (i >> 2) * (1461 * 24 * 60 * 60);
    x += (i & 3) * (24 * 60 * 60 * 365);

    if (i & 3)  x += 24 * 3600;
    days = 0;
    i = da_mon - 1;                      /* Add in months */
    while (i > 0)   {
        i--;
        val(tt,copy(DaysS,(i*2)+1,2));
        days += tt;
    }

    days += da_day - 1;
    if ( da_mon > 2 && (da_year & 3) == 0 )
        days++;                         /* Currently in leap year */

    hours = days * 24 + ti_hour;         /* Find hours */

    x += hours * 3600;
    x += 60 * ti_min + ti_sec;

    make_message( hex_str( x ) );
    return ( hex_str(x) );
}


/* ------------------------------------------------------------

 NAME:         MAKE_FREQ

 DESCRIPTION:  Creates .MSG file of file request

 PARAMETERS:   fname= from-name
               tname= to-name
               faddr= from-addres
               taddr= to-addres
               files= files-to-request

 RETURNS:      0 if no errors

-------------------- 21-Jul-93 03:44pm ---------------------- */

int make_freq ( str fname,tname,faddr,taddr,files,path,filnam ) TRANS2
{   int ii, jj, nn, han, flags;
    str dnode[2], onode[2], dnet[2], onet[2], tt[20], attr[2];
    str d_t[30], filler[40], msgid[8];

    pad_str(fname,36,'|0');
    pad_str(tname,36,'|0');
    pad_str(files,71,' ');
    files += char(0);

    msgid = getunixtime();

    if ( s_create_file(path+filnam,han) != 0 )  goto badex;

    make_message( 'File request: "'+ path+filnam +'" created.');
    if ( s_write_bytes(fname,han,nn ) != 0 )    goto badex;
    if ( s_write_bytes(tname,han,nn ) != 0 )    goto badex;

    attr = get_attr(files);
    flags = return_int;

    if ( s_write_bytes(files,han,nn ) != 0 )    goto badex;

    d_t = dtime();
    pad_str(d_t,20,'|0');
    if ( s_write_bytes(d_t,han,nn ) != 0 )    goto badex;

    tt = char(0)+char(0);
    if ( s_write_bytes(tt,han,nn ) != 0 )    goto badex; // count

    dnode = get_node( taddr );
    onode = get_node( faddr );
    dnet  = get_net( taddr );
    onet  = get_net( faddr );

    if ( s_write_bytes(dnode,han,nn ) != 0 )    goto badex;
    if ( s_write_bytes(onode,han,nn ) != 0 )    goto badex;

    if ( s_write_bytes(tt,han,nn ) != 0 )       goto badex; //cost

    if ( s_write_bytes(onet,han,nn ) != 0 )     goto badex;
    if ( s_write_bytes(dnet,han,nn ) != 0 )     goto badex;

    filler = '';
    pad_str(filler,10,char($55));
    if ( s_write_bytes(filler,han,nn ) != 0 )   goto badex;

    if ( s_write_bytes(attr,han,nn ) != 0 )       goto badex;

    tt = char(0)+char(0);
    if ( s_write_bytes(tt,han,nn ) != 0 )       goto badex;
    //if ( s_write_bytes(tt,han,nn ) != 0 )       goto badex;

    // -------------------- Kludges ----------------------
    if ( get_pt(taddr) != '') {
        filler = char(1)+'TOPT '+get_pt(taddr)+char(13)+char(10);
        if ( s_write_bytes(filler,han,nn ) != 0 )       goto badex;
    }

    filler = char(1)+'FMPT '+get_pt(faddr)+char(13)+char(10);
    if ( s_write_bytes(filler,han,nn ) != 0 )       goto badex;

    // Direct in Kludge if needed
    if ( (flags & MA_Direct) != 0 ) {
        filler = char(1)+'FLAGS DIR'+char(13)+char(10);
        if ( s_write_bytes(filler,han,nn ) != 0 )       goto badex;
    }

    // Flag FPU in Kludge if needed
    if ( (flags & MA_FPU) != 0 ) {
        filler = char(1)+'FLAGS FPU'+char(13)+char(10);
        if ( s_write_bytes(filler,han,nn ) != 0 )       goto badex;
    }

    filler = char(1)+'MSGID: '+faddr+' '+msgid+char(13)+char(10);
    if ( s_write_bytes(filler,han,nn ) != 0 )       goto badex;

    //filler = char(1)+'REPLY: '+taddr+' '+msgid+char(13)+char(10);
    //if ( s_write_bytes(filler,han,nn ) != 0 )       goto badex;

    filler = char(1)+'PID: '+YF_S_NAME+char(13)+char(10)+char(13)+char(10);
    if ( s_write_bytes(filler,han,nn ) != 0 )       goto badex;

    s_close_file(han);
ex:
    return ( 0 );
badex:
    return ( 1 );
}

// Tries to find size of file just put to FREQ buffer
/* --------------------------------------------------------------- */
            int get_freq_size(int dummy) {
/* --------------------------------------------------------------- */
int ii, res;

    mark_pos;
    if ( find_text("[0-9]+ ",1,_RegExp | _OldExp) ) {
      ii = val( res, copy( found_str, 1, length( found_str ) - 1 ) );
      if ( ii != 0 ) res = 0;
    }
    else res = 0;

    goto_mark ;
    return ( res );
}


/* ------------------------------------------------------------

 NAME:         GET_FILE

 DESCRIPTION:  Requests file at current line in file

 PARAMETERS:

 RETURNS:

-------------------- 29-Jul-93 11:40pm ---------------------- */
macro GET_FILE {
int ii, jj, bs, orf, cw, y, fnd_line, len, csize=0, osize;
str file[30], s1[128], srch_w[40];

    if ( chk_reqbuf(0,ii) == 0 ) {
      make_freq_win( 0 );
      if ( chk_reqbuf(0,ii) == 0 ) goto ex;
    }
    else if ( make_freq_win( 1 ) == 0 ) goto ex;

    mark_pos;
    y = 4 ;
    if ( c_row < 12 )  y = win_y2 - 12;

    srch_w = parse_str('/SRCH=',global_str('!YFREQ_REQID'));

    // If stream or col block active - use it
    bs = block_stat;
    if ( bs>1 && (block_line1 == block_line2 ) ) {
        goto_line( block_line1 );
        goto_col( block_col1 );
        fnd_line = block_line1;

        len = block_col2-block_col1+1;
        file = remove_space( copy( get_line,block_col1,len) );
        file = caps( file );
        block_off;
    }
    else {
        goto_col(1);
        left;
        ii = find_text(srch_w,0,_RegExp | _OldExp);
        fnd_line = c_line;

        if ( ii == 0 )  {
            goto_mark;
            goto ex;
        }
        file = caps( remove_space( found_str ) );
        len = svl( file );
    }

    csize = get_freq_size(0);
    mark_found_str( file );
    uncenter_line();
    new_screen;

    y = 4 ;
    if ( c_row < 12 )  y = win_y2 - 12;

    Return_Str = file;
    RM("USERIN^QUERYBOX /W=20/P=FREQ it?:/T=" +
        "Total size in buff: " + str( global_int('!YFREQ_TSIZE') ) +
        " bytes/C=3/L="+str(y));
    if ( return_int == 0 ) {
        goto_mark;
        down;
        goto ex;
    }
    else {
        set_global_int('!YFREQ_TSIZE',global_int('!YFREQ_TSIZE')+csize);
        pop_mark;
        goto_line(fnd_line);
        goto_col(1);
        down;
        file = return_str;
    }

    orf = refresh ;
    refresh = 0;
    cw = cur_window;

    RM('YFREQ^CORR_WIND');
    if ( chk_reqbuf(1,ii) == 0 ) {
    no_rbuf:
        RM('MEERROR^MESSAGEBOX /B=1/M=Request buffer not found!');
        goto ex1;
    }

    //tof; if ( at_eof ) text(' ');
    eof; eol;
    s1 = copy( get_line, 72, 9 );

    put_line( remove_space( copy(get_line,1,70) ) );
    if ( length( get_line ) + svl(file)+1 > 70 ) {
        goto_col(71); text( ''+ s1 );
        beep;
        cr;
        s1 = '';
    }

    s1 = remove_space( s1 );
    block_off;
    eol;
    if ( c_col >1 )  text(' ');
    col_block_begin;
    text(file);
    left;
    block_end;
    right;

    val(osize,s1);
    goto_col( 71 );
    text( ''+str(osize+csize) );
ex1:
    switch_window( cw );
    refresh = orf;
ex:
    block_off;
    new_screen;
}


/* ------------------------------------------------------------

 NAME:         CRE_FREQ

 DESCRIPTION:  Creates the FILE request.

 PARAMETERS:   \F= from-name
               \T= to-name
               \FA= from-addres
               \TA= to-addres
 RETURNS:

-------------------- 21-Jul-93 03:44pm ---------------------- */
int CRE_FREQ (str fname, tname, faddr, taddr, path) {
str files[80], filnam[15];
int ii, nfiles, kk, i1, i2, orf, cw;

    orf = refresh ;
    refresh = 0;
    mark_pos;
    cw = cur_window;

    if ( chk_reqbuf(1,ii) < 2 )
        goto ex;

    // Get the name of .MSG file
    ii = find1st_msg (path, filnam) ;

    nfiles = 0;
    while ( not(at_eof) ) {
        files = remove_space( copy(get_line,1,70) );
        filnam = str(++ii) + '.MSG';
        make_freq( fname,tname,faddr,taddr,files,path,filnam );
        ++nfiles;
        del_line;
    }

#ifdef YF_S_RESCAN
    force_rescan(YF_S_RESCAN);
#endif

ex:
    switch_window( cw );
    goto_mark;
    refresh = orf;
    new_screen;
    return ( nfiles );
}


/* ------------------------------------------------------------

 NAME:         YF_GEN_FREQ

 DESCRIPTION:  Asks for destination address and name and flush
    the request buffer.

 PARAMETERS:

 RETURNS:

-------------------- 29-Jul-93 09:31pm ---------------------- */
macro YF_GEN_FREQ {
str taddr[30], tname[40], faddr[30], fname[40], path[60], s1[200];
int ii, jj, cw, orf, nfiles=0, ow, sts;

    cw = window_id;
    orf = refresh;
    refresh = 0;

    if ( chk_reqbuf(1,ow) < 2 ) {
    no_rbuf:
        RM('MEERROR^MESSAGEBOX /B=1/M=Request buffer not found or empty!');
        goto ex;
    }
    if ( (sts = chk2semaphores()) != 0 ) {
        goto ex;
    }

    tof;
    if ( at_eof ) goto no_rbuf;

    switch_win_id( cw );
    RM('YFREQ^GET_ADDR');
    if ( return_int == 0 ) goto ex;

    if ( GET_F_PARM(0) == 0 )    {
        make_message( 'No FREQ generated!' );
        goto ex;
    }

    nfiles = CRE_FREQ (
            YF_S_FROMNAME,
            global_str('!YFREQ_TNAME'),
            YF_S_FROMADDR,
            global_str('!YFREQ_TADDR'),
            YF_S_MSGDIR
        );

    set_global_str('!YFREQ_TADDR','');
    set_global_str('!YFREQ_TNAME','');
    set_global_int('!YFREQ_TSIZE',0);
ex:
    if (sts == 0) clr_semaphore();  // If created semaphore - delete it

    switch_win_id( cw );
    make_message( 'Generated: '+str(nfiles)+' files.' );
    set_global_int('!YFREQ_TSIZE',0);
    if ( block_stat )   block_off;
    if (sts == 0) del_req_buf( Not(nfiles>0) );

    refresh = orf;
}



/* ------------------------------------------------------------

 NAME:         YF_GEN_ATT

 DESCRIPTION:  Asks for destination address and name and
        generates FILE ATTACH. FileName is last name from DIR_SHELL

 PARAMETERS:

 RETURNS:

-------------------- 29-Jul-93 09:31pm ---------------------- */
macro YF_GEN_ATT {
str taddr[30], tname[40], faddr[30],
    fname[40], path[60], filnam[40]='', files[80];
int ii, jj, cw, orf, nfiles=0, ow, flags, oflags, trnk=0, nn;

    cw = window_id;
    orf = refresh;
    refresh = 0;

    RM('DIRSHELL');
    oflags = global_int( '!YFREQ_FATTR');

    flags = (((YF_S_FATTR) & ($FFFF ^ MA_FileReq)) | MA_FileAtt) | MA_Direct;
    set_global_int( '!YFREQ_FATTR',flags);

    if ( GET_F_PARM(1) == 0 )    {
        make_message( 'No ATTACH generated!' );
        goto ex;
    }

    files = '';
    dos_home;
    nn = 0;
    for ( ii=0; ii<dir_total; ii++ ) {
        if ( file_marked ) {
            if ( (length(files)+length(dir_entry)) > 72 ) {
                ++trnk;
                break;
            }
            files += dir_entry + ' ';
            mark_file;
            ++nn;
        }
        dos_down;
    }

    if ( nn < 1 ) {
        rm('MEERROR^MESSAGEBOX /B=1/M=No files marked in DIR_SHELL!');
        goto ex;
    }

    ii = find1st_msg (YF_S_MSGDIR, filnam) ;
    filnam = str(++ii) + '.MSG';

    make_freq(
            YF_S_FROMNAME,
            global_str('!YFREQ_TNAME'),
            YF_S_FROMADDR,
            global_str('!YFREQ_TADDR'),
            files,
            YF_S_MSGDIR,
            filnam
        );

    set_global_str('!YFREQ_TADDR','');
    set_global_str('!YFREQ_TNAME','');
ex:
    switch_win_id( cw );
    if (trnk==0) {
        if ( filnam != '')
          make_message( 'Generated FILEATTACH: '+YF_S_MSGDIR+filnam+'.' );
    }
    else {
        make_message( 'Not all files sent, call macro again...' );
        beep;
    }

    if ( block_stat )   block_off;
    set_global_int( '!YFREQ_FATTR',oflags);
    refresh = orf;
}



/* ------------------------------------------------------------

 NAME:         GET_F_PARM

 DESCRIPTION:  User interface to set main parameters;

 PARAMETERS:   'dflt' - if non zero uses defaults for name & address
               of TO: node.
 RETURNS:

-------------------- 21-Jul-93 09:17pm ---------------------- */
            int GET_F_PARM (int dflt) {
str cpath[80], s1[80] ;
int ii, jj, stat=1;

    if ( global_str('!YFREQ_TNAME') == '') {
        if ( dflt )
            set_global_str('!YFREQ_TNAME',YF_S_TONAMEDFLT);
    }

    if ( global_str('!YFREQ_TADDR') == '') {
        if ( dflt )
            set_global_str('!YFREQ_TADDR',YF_S_TOADDRDFLT);
    }

m_loop:
    set_global_str('!YK!IPARM_1','/TP=0/L=1/C=2/W=40/T=   TO name:');
    set_global_str('!YK!ISTR_1',global_str('!YFREQ_TNAME'));
    set_global_str('!YK!IPARM_2','/TP=0/L=2/C=2/W=16/T=TO address:');
    set_global_str('!YK!ISTR_2',global_str('!YFREQ_TADDR'));
    set_global_str('!YK!IPARM_3','/TP=0/L=3/C=2/W=40/T=  MSG Path:');
    set_global_str('!YK!ISTR_3',YF_S_MSGDIR);

    rm('userin^data_in /#=3/PRE=!YK!/X=10/Y=6/S=1/T= YFREQ ');

    if ( global_str('!YFREQ_TNAME') == '') {
    }
    set_global_str('!YFREQ_TNAME',global_str('!YK!ISTR_1'));
    set_global_str('!YFREQ_TADDR',global_str('!YK!ISTR_2'));
    if ( global_str('!YFREQ_TADDR') == '' ) stat = 0;
    else
      set_global_str('!YFREQ_TADDR',corr_addr(global_str('!YFREQ_TADDR')));

    set_global_str('!YK!ISTR_1','');
    set_global_str('!YK!ISTR_2','');
    set_global_str('!YK!ISTR_3','');

    set_global_str('!YK!IPARM_1','');
    set_global_str('!YK!IPARM_2','');
    set_global_str('!YK!IPARM_3','');

    if ( return_int == 0 ) {
        stat = 0;
        goto ex;
    }

    if ( global_str('!YFREQ_TNAME') == '' ) {
        RM( 'YFREQ^GET_NAME' );
        if ( (stat = return_int) != 0 ) goto m_loop;
    }
ex:
    return ( stat );
}

//#define YF_DEBUG Yes
/* ------------------------------------------------------------

 NAME:         FREQ_COND

 DESCRIPTION:  Displays current help as it will in Hypertext,
               i.e. wo/@XXX[], Globals references keys etc, are
               inserted when possible.

 NOTE:          Actually its modified system SUPPORT^CONDENSE macro -
                so may be not as efficient as poss.
                But quickly written. ;-)
 --------------------- 14-Jul-93 05:11pm ---------------------- */

Macro FREQ_COND TRANS2 {

/* ============================================================= */

    int Up_Count,Temp_Line_Num,New_Line_Num,At_Top,At_Bottom,
        Temp_Integer,Line_Amount,Text_Window,Line_Window,Repaint,
        Left_Side,Width,Top,Write_Line,X2,Y2,Start_Line,Cursor_Line,Counter,
        Normal,Temp_Tab_Expand,Using_Search,Temp_Reg_Exp_Stat,
        Temp_Insert_Mode,Temp_Ignore_Case, twin,Scroll_Pos,T_Mou_X,T_Mou_Y,
        first_time;

	str Temp_String,Search_String,Search_Switches[8],Temp_Search;
    str yss, yss1[60], yss2[60], yss3[80], syear[5];
    int ymenu = menu_create,
        yi1, yi, yi2, nnn, old_col, dday, dmon, dyear, usdat;
    str s_year = 'JanFebMarAprMayJunJulAugSepOctNovDec';

	Set_Global_Int('MENU_LEVEL', Global_Int('MENU_LEVEL') + 1);
	Temp_Reg_Exp_Stat = Reg_Exp_Stat;
	Temp_Ignore_Case = Ignore_Case;
	Temp_Tab_Expand = Tab_Expand;
	Temp_Insert_Mode = Insert_Mode;
	Tab_Expand = False;
	Undo_Stat = False;
	Insert_Mode = True;

    usdat = ( Global_Int("@RADIO@") == 2) ;
    menu_set_item(ymenu,1,"Files newer than:",global_str('!YFREQ_COND'),
        "/QK=1/L=1/C=2/W=8/ML=8",0,0,0);
    menu_set_item(ymenu,2,"Date format (in list): ","","/QK=1/L=2/C=2",10,0,0);
    menu_set_item(ymenu,3,"mm-dd-yy  ","","/L=3/C=2/G=@RADIO@/R=2",12, usdat==1 ,0);
    menu_set_item(ymenu,4,"dd-mm-yy  ","","/L=4/C=2/G=@RADIO@/R=1",12, usdat!=1 ,0);
    Return_Int = ymenu;
    RM("USERIN^DATA_IN /HN=1/PRE=EX/#=4/T=Seek for NEW files/H=DATABOX");
    if ( Return_Int == 0 ) goto end_of_mac;

    yss = menu_item_str(ymenu,1,2);

    set_global_str('!YFREQ_COND', yss);
    usdat = ( Global_Int("@RADIO@") == 2) ;

    if ( usdat ) {
        val(dday, copy(yss,4,2));
        val(dmon, copy(yss,1,2));
    }
    else {
        val(dday, copy(yss,1,2));
        val(dmon, copy(yss,4,2));
    }

    syear = copy(yss,7,2);
    val(dyear,copy(yss,7,2));
    yss = str(dday) + '-' + copy(s_year,((dmon - 1) * 3) + 1,3) +
        '-' + syear;

    Using_Search = 1;
    Reg_Exp_Stat = True;
    Search_String = '[0-9][0-9][-./]+[0-9][0-9[-./]+[0-9][0-9]';

	Push_Labels;
	Messages = False;
	Left_Side = Win_X1 + 2;
	Cursor_Line = Win_Y1 + 1;
	Width = (Win_X2 - Win_X1) - 1;
	Top = Win_Y1 + 1;
	Line_Amount = (Win_Y2 - Win_Y1) - 1;
	X2 = Win_X2;
	Y2 = Win_Y2;
	Text_Window = Cur_Window;
	Temp_Line_Num = C_Line;
#ifndef YF_DEBUG
    Refresh = False;
#else
    Refresh = true;
#endif

	Normal = True;

    old_col = c_col;

	Create_Window;
/* make window the same as the text window */
#ifdef YF_DEBUG
    Window_Attr = 0;
#else
    Window_Attr = $80;
#endif
	Size_Window(Left_Side - 2,Top - 1,X2,Y2);
	Line_Window = Cur_Window;
	Switch_Window(Text_Window);
	Repaint = False;
	At_Top = False;
	At_Bottom = False;
	Write(Copy('',1,Width),Win_X1 + 1,Win_Y1,0,B_Color);
    Write('YFREQ-CONDENSED SEARCH FOR:'+yss,(Width / 2) - 17,Win_Y1,0,M_H_Color);
	Make_Message('');
	Start_Line = Temp_Line_Num;
	Up_Count = Line_Amount / 2;
	first_time = true;

    Up_Count = 0;
	Call GET_LINES;
	Call GET_LINE_NUM;
	Check_Key;

MAIN_LOOP:
/*
Make_Message('AT_TOP=' + Str(AT_TOP) + ' AT_BOTTOM=' + STR(AT_BOTTOM) +
							' LINE_AMOUT=' + Str(LINE_AMOUNT) + ' C_LINE=' + Str(C_Line));
 */
	Read_Key;
	Insert_Mode = True;
	if(  ((Key1 == 27) | (Key1 == 13))  ) {
		Goto LOOP_EXIT;
	}
	if(  (Key1 == 0)  ) {
		if(  ((Key2 == 244) | (Key2 == 245))  ) {
			Goto LOOP_EXIT;
		}
		Call GET_KEY;
	}
	Goto MAIN_LOOP;

LOOP_EXIT:
	Switch_Window(Line_Window);
	Val(New_Line_Num,Get_Line);

	if(  ((Key1 == 27) | (New_Line_Num == 0) | (Key2 == 245))  ) {
		New_Line_Num = Temp_Line_Num;
	}

	Delete_Window;

	Switch_Window(Text_Window);

	Refresh = True;

	while(  (C_Row > ((Win_Y2 - Win_Y1) / 2))  ) {
		Up;
	}
	while(  (C_Row < ((Win_Y2 - Win_Y1) / 2))  ) {
		Down;
	}
	Goto_Line(New_Line_Num);
	Goto END_OF_MAC;

GET_LINES:
	Switch_Window(Line_Window);
/* special development code for calculating elapsed time
If ((Val(Start_Minutes,Copy(Time,4,2))) and (Val(Start_Seconds,Copy(Time,7,2)))) Then
End;
 */

/* Determine the line to start looking at */
	if(  ((Up_Count > 0) | (Repaint == True))  ) {
		Tof;
	} else {
		Goto_Line(Line_Amount);
	}

	if(  (Get_Line != '')  ) {
		Val(Start_Line,Get_Line);
	} else {
		Start_Line = Temp_Line_Num;
	}
GET_LINES2:
/* Clear displayed lines */
	Temp_Integer = Top + Line_Amount;
	Counter = Top;
	while(  (Counter < Temp_Integer)  ) {
		Draw_Char(32,Left_Side - 1,Counter,Text_Color,Width);
		++Counter;
	}

	Tof;
/* Delete all lines in line number file */
	while(  Not(At_Eof)  ) {
		Del_Line;
	}
/* Find top line */
	Switch_Window(Text_Window);
	if(  (Normal == True)  ) {
		Goto_Line(Start_Line);
	}

	At_Top = False;

	if(  (Up_Count == 0)  ) {
		Goto PAGING_DOWN;
	}

	Counter = Up_Count;
SEEK_UP:
    Working;
srch01:
    if (first_time) {
        eol;
        first_time = false;
    }
    if (Search_Bwd(Search_String,0)) {
        call chg_str;
        if ( return_int==0 ) {
            goto_col(1);
            goto srch01;
        }

        Temp_String = Str(C_Line);
        Switch_Window(Line_Window);
        Cr;
        Up;
        Put_Line(Temp_String);
        Switch_Window(Text_Window);
        --Counter;
        if(  (C_Line == 1)  ) {
            Goto TOP_FOUND;
        }
        Up;
        goto_col(1);
        if(  (Counter > 0)  ) {
            Goto srch01;
        }
    }
    else tof;

TOP_FOUND:
    Working;
	At_Top = (C_Line == 1) | (At_Top);
	Down;
	Switch_Window(Line_Window);
	Tof;

	while(  (Up_Count > Counter)  ) {
		Switch_Window(Line_Window);
		Val(Temp_Integer,Get_Line);
		Write_Line = (C_Line + Top) - 1;
		Down;
		Switch_Window(Text_Window);
		Goto_Line(Temp_Integer);
		Write(Copy(Get_Line,1,Width),Left_Side - 1,Write_Line,0,Text_Color);
		--Up_Count;
	}

	Switch_Window(Text_Window);
	Down;
PAGING_DOWN:
	At_Top = (C_Line == 1) | (At_Top);

	At_Bottom = False;
	Switch_Window(Line_Window);
	Write_Line = (C_Line + Top) - 2;
	Counter = C_Line;
	Switch_Window(Text_Window);
	if(  (Counter > Line_Amount)  ) {
		Goto NO_MORE_LINES;
	}

SEEK_DOWN:
    Working;
srch02:
    if(  (Search_Fwd(Search_String,0))  ) {
        call chg_str;
        if ( return_int==0 ) {
            eol;
            goto srch02;
        }

        Temp_Integer = C_Line;
        Switch_Window(Line_Window);
        Put_Line(Str(Temp_Integer));
        Down;
        Switch_Window(Text_Window);
        Write(Copy(Get_Line,1,Width),Left_Side - 1,(Counter + Top) - 1,0,Text_Color);
        Down;
        goto_col(1);
        ++Counter;
        if(  (At_Eof)  ) {
            Goto NO_MORE_LINES;
        }
        if(  (Counter <= Line_Amount)  ) {
            Goto srch02;
        }
    }
    else eof;

NO_MORE_LINES:
    Working;
	At_Bottom = (At_Eof) | (At_Bottom);
	Switch_Window(Line_Window);
	Tof;
	if(  (Search_FWD(Str(Start_Line),0) == False)  ) {
/* If we weren't on a displayable line when we entered condense, we need to find
the nearest displayable line above it. */
FIND_START_LINE:
		if(  (Val(Counter,Get_Line) == 0)  ) {
			if(  (Counter < Start_Line)  ) {
				Down;
				Goto FIND_START_LINE;
			}
		}
		Up;
	}
	goto_col(1);

	Cursor_Line = C_Line + Win_Y1;
	GotoXY(Left_Side - 1,Cursor_Line);
	RET;

GET_KEY:
	if(  (Key2 == 251)  ) {
		if(  (Mou_Last_X == Win_X2) & (Mou_Last_y > (win_y1 + 1)) &
			(Mou_Last_y < (win_y2 - 1))  ) {
			Switch_Window(Text_Window);
			RM('MOUSE^GotoScrollBar');
			Start_Line = C_Line;
			Switch_Window(Line_Window);
			Erase_Window;
			Up_Count = Line_Amount / 2;
			Call GET_LINES2;
			Call GET_LINE_NUM;
			Ret;
		}
	}
	if(  (Key2 == 250)  ) {
		T_Mou_X = Mou_Last_X;
		T_Mou_Y = Mou_Last_Y;
		if(  (Mou_Last_X == Win_X2)  ) {
			if(  (mou_last_y == (win_y2 - 1))  ) {
				Goto SCROLL_UP;
			} else if(  (mou_last_y == (win_y1 + 1))  ) {
				Goto SCROLL_DOWN;
			} else if(  (Mou_Last_y > win_y1) & (Mou_Last_y < win_y2)  ) {
				Temp_Integer = Mou_Last_Y - Win_Y1 - 1;
				Switch_Window(Text_WIndow);
				Scroll_Pos = Cur_Scroll_Pos;
				Switch_Window(Line_WIndow);
				if(  (Temp_Integer > scroll_pos)  ) {
					Goto page_down;
				} else if(  (Temp_Integer < scroll_pos)  ) {
					Goto page_up;
				}
			}
		} else if(  (Mou_Last_Y == Fkey_ROW)  ) {
			RM('MOUSE^MOUSEFKEY');
			Ret;
		} else if(  ((Mou_Last_Y > Win_Y1) & (Mou_Last_Y < Win_Y2) &
					(Mou_Last_X > Win_X1) & (Mou_Last_X < Win_X2))  ) {
/* Check to see if mouse was clicked inside the window */
			Counter = C_Line;
			Goto_Line(Mou_Last_Y - Win_Y1);
			if(  (C_Line == Counter)  ) {
				Push_Key(13,28);
				Ret;
			}
			if(  (At_Eof)  ) {
				Goto_Line(Counter);
			}
			Cursor_Line = C_Line + Win_Y1;
			GotoXY(Left_Side - 1,Cursor_Line);
		} else {
			RM('USERIN^CHECKEVENTS /M=1/G=CONDENSEEV/#=3');
			if(  (Return_Int)  ) {
				Push_Key(Parse_Int('/K1=',Global_Str('CONDENSEEV' + Str(Return_Int))),
								 Parse_Int('/K2=',Global_Str('CONDENSEEV' + Str(Return_Int))));
				Ret;
			}
		}
	}
	if(  ((Key2 == 72) | (Key2 == 240))  ) { /* Up arrow */
		if(  (C_line > 1)  ) {
			Up;
			Eol;
			--Cursor_Line;
			GotoXY(Left_Side - 1,Cursor_Line);
		} else {
SCROLL_DOWN:
			if(  Not(At_Top)  ) { /* Scroll down */
				Counter = C_Line;
/* Check for at bottom */
				Switch_Window(Line_Window);
				Goto_Line(Line_Amount);
				Goto_Col(1);
				At_Bottom = At_Eof;
				Del_Line;
/* Goto the top line */
				Tof;
				Val(Start_Line,Get_Line);
/* Look for the next line up in the text file */
				Switch_Window(Text_Window);
				Goto_Line(Start_Line);
				Up;
				Eol;
        srch1:
                if(  (Search_Bwd(Search_String,0))  ) {
                    call chg_str;
                    if ( return_int==0 ) {
                        goto_col(1);
                        goto srch1;
                    }
                    Temp_Integer = C_Line;
                    Scroll_Box_Dn(Left_Side - 1,Top,X2 - 1,Y2 - 1,(Back_Color << 4) | Text_Color);
                    Write(Copy(Get_Line,1,Width),Left_Side - 1,(Counter + Top) - 1,0,Text_Color);

                    //Write(yss,Left_Side - 1,Top,0,Text_Color);
                    At_Top = (C_Line == 1);
                    Switch_Window(Line_Window);
/* Delete bottom line */
                    Goto_Line(Line_Amount);
                    Del_Line;
/* Goto the top line and insert new line above it */
                    Tof;
                    Cr;
                    Up;
                    Put_Line(Str(Temp_Integer));
                } else {
                    At_Top = True;
                }
NO_SCROLL_DOWN:
				Switch_Window(Line_Window);
				if(  (Key2 == 250)  ) {
					Goto_Line(Counter);
					Mou_Repeat = True;
CHECK_STAT2:
					Mou_Check_Status;
					if(  ((Mou_Last_Status & 1) == 0) | (T_Mou_x != Mou_Last_X) |
							(T_Mou_y != Mou_Last_Y)  ) {
						GOTO MOU_SCROLL_DOWN_EXIT;
					}
					if(  check_key  ) {
						if(  (key1 != 0) & (key2 != 250)  ) {
							push_key(key1, key2);
							GOTO MOU_SCROLL_DOWN_EXIT;
						}
						Call GET_LINE_NUM;
						goto scroll_DOWN;
					}
					goto CHECK_STAT2;
MOU_SCROLL_DOWN_EXIT:
					Mou_Repeat = False;
				}
			}
		}
	}

	if(  ((Key2 == 80) | (Key2 == 241))  ) { /* Down arrow */
		if(  ((C_line < Line_Amount) & (Not(At_Eof)))  ) {
			Down;
			Eol;
			++Cursor_Line;
			GotoXY(Left_Side - 1,Cursor_Line);
		} else {
SCROLL_UP:
			if(  Not(At_Bottom)  ) { /* Scroll up */
				Counter = C_Line;
/* Goto the bottom line */
				Goto_Line(Line_Amount);
				Val(Start_Line,Get_Line);
				Switch_Window(Text_Window);
				Goto_Line(Start_Line);
				Eol;
				if(  (At_Eof)  ) {
					At_Bottom = True;
					Goto NO_SCROLL_UP;
				}

/* Delete top line in line window */
				At_Top = False;
				Switch_Window(Line_Window);
				Tof;
				Del_Line;
				Goto_Line(Line_Amount);
				Scroll_Box_UP(Left_Side - 1,Top,X2 - 1,Y2 - 1,(Back_Color << 4) | Text_Color);

/* Look for the next line down in the text file */
				Switch_Window(Text_Window);
            srch2:
                if(  (Search_Fwd(Search_String,0))  ) {
                    call chg_str;
                    if ( return_int==0 ) {
                        eol;
                        goto srch2;
                    }
                    Temp_Integer = C_Line;
                    Switch_Window(Text_Window);
                    Write(Copy(Get_Line,1,Width),Left_Side - 1,(Counter + Top) - 1,0,Text_Color);
                    Eol;
                    At_Bottom = At_Eof;
                    Switch_Window(Line_Window);
                    Put_Line(Str(Temp_Integer));
                } else {
                    At_Bottom = True;
                }
NO_SCROLL_UP:
				Switch_Window(Line_Window);
				if(  (Key2 == 250)  ) {
					Goto_Line(Counter);
					Mou_Repeat = True;
CHECK_STAT1:
					Mou_Check_Status;
					if(  ((Mou_Last_Status & 1) == 0) | (T_Mou_x != Mou_Last_X) |
							(T_Mou_y != Mou_Last_Y)  ) {
						GOTO MOU_SCROLL_UP_EXIT;
					}
					if(  check_key  ) {
						if(  (key1 != 0) & (key2 != 250)  ) {
							push_key(key1, key2);
							GOTO MOU_SCROLL_UP_EXIT;
						}
						Call GET_LINE_NUM;
						goto scroll_up;
					}
					goto CHECK_STAT1;
MOU_SCROLL_UP_EXIT:
					Mou_Repeat = False;
				}
			}
		}
	}
	if(  (Key2 == 73)  ) {
PAGE_UP:
		if(  (At_Top)  ) { /* Page up */
			Tof;
			Cursor_Line = Win_Y1 + 1;
			GotoXY(Left_Side - 1,Cursor_Line);
		} else {
			Up_Count = Line_Amount;
			Call GET_LINES;
		}
	}
	if(  (Key2 == 81)  ) {
PAGE_DOWN:
		Goto_Col(1);
		if(  (At_Bottom)  ) { /* Page down */
			while(  Not(AT_EOF)  ) {
				Down;
				++Cursor_Line;
			}
			Up;
			--Cursor_Line;
			GotoXY(Left_Side - 1,Cursor_Line);
		} else {
			Up_Count = 0;
			Call GET_LINES;
		}
	}
	if(  ((Key2 == 119) & (Not(At_Top)))  ) { /* Top of file */
		Switch_Window(Text_Window);
		Tof;
		Up_Count = 0;
		Normal = False;
		Call GET_LINES;
		Normal = True;
		At_Top = True;
	}
	if(  ((Key2 == 117) & (Not(At_Bottom)))  ) { /* Bottom_Of_File */
		Switch_Window(Text_Window);
		Eof;
		goto_col(1);
		while(  (At_Eol)  ) {
			Up;
		}
		Up_Count = Line_Amount;
		Normal = False;
		Call GET_LINES;
		Goto_Line(Line_Amount);
		Cursor_Line = C_Line + Win_Y1;
		GotoXY(Left_Side - 1,Cursor_Line);
		Normal = True;
		At_Bottom = True;
	}

	Call GET_LINE_NUM;
	RET;

GET_LINE_NUM:
	if(  (Val(New_Line_Num,Get_Line))  ) {
		New_Line_Num = 0;
	}
	Put_Line_Num(New_Line_Num);

	Set_Global_Str('CONDENSEEV1','/T=Select/KC=<ENTER>/W=18/K1=13/K2=28/R=13/Y=' +
			Str(Message_Row) + '/X=1');
	Set_Global_Str('CONDENSEEV2','/T=Cancel/KC=<ESC>/W=11/K1=27/K2=1/R=13/Y=' +
			Str(Message_Row) + '/X=15');
    Set_Global_Str('CONDENSEEV3','/T=New Files./KC=/W=28/K1=0/K2=61/R=61/Y=' +
            Str(Message_Row) + '/X=28');

	RM('USERIN^CHECKEVENTS /M=2/G=CONDENSEEV/#=3');
	switch_window( text_window );
	while(  c_row > 1  ) {
		up;
	}
	goto_line( new_line_num );
	update_scroll_bar;
	switch_window( line_window );
	RET;

PROCESS_MOUSE:
	RET;

// yk
CHG_STR:
    yss1 = found_str;
    val(yi1,copy(yss1,7,2));         // Year
    if ( yi1 < dyear ) {
    bad_l:
        return_int = 0;
        ret;
    }
    if ( usdat ) {
        val(yi1,copy(yss1,1,2));      // Month
    }
    else {
        val(yi1,copy(yss1,4,2));      // Month
    }

    if ( yi1 < dmon ) goto bad_l;
    else if ( yi1 == dmon ) {
        if ( usdat ) {
            val(yi2,copy(yss1,4,2));      // Day
        }
        else {
            val(yi2,copy(yss1,1,2));      // Day
        }
        if ( yi2 < dday ) goto bad_l;
    }
fnd:
    return_int = 1;
    RET;


END_OF_MAC:
	RM('USERIN^CHECKEVENTS /M=3/G=CONDENSEEV/#=3');
	Tab_Expand = Temp_Tab_Expand;
	Reg_Exp_Stat = Temp_Reg_Exp_Stat;

	Insert_Mode = Temp_Insert_Mode;
	Ignore_Case = Temp_Ignore_Case;
	Undo_Stat = True;
	Kill_Box;
	Refresh = True;
	Make_Message('');
	Set_Global_Int('MENU_LEVEL', Global_Int('MENU_LEVEL') - 1);
	Pop_Labels;
	Messages = True;
	New_Screen;
    goto_col(1);
    menu_delete( ymenu );
}

